'*
'*  counting german Umlaute
'*  bestimmt die Anzahl der Umlaute im String
'***********************************************************************
FUNCTION UmlAz(BYREF T AS STRING) AS INTEGER
  DIM AS INTEGER p, z = ASC(ConvUTF), n
  FOR p = 0 TO LEN(T) - 1
    IF T[p] = z THEN p += 1 : n += 1
  NEXT : RETURN n
END FUNCTION

'*
'*  generating a comment line
'*  Erzeugt Kommentar-zeile (links- und rechtsbündug)
'***********************************************************************
FUNCTION tobac_zeile(BYVAL L AS STRING, BYVAL R AS STRING) AS STRING
  DIM AS INTEGER n = 70 + UmlAz(L) + UmlAz(R)
  DIM AS STRING s = RIGHT(SPACE(n) + R, n)
  MID(s, 1, LEN(s)) = L : RETURN s + " >" & NL
END FUNCTION

'*
'*  generating start comments for all files
'*  Erzeugt Start-Kommentar für alle Dateien
'***********************************************************************
SUB tobac_top(te AS STRING, td AS STRING)
  ausg  = tobac_C_sta
  ausg += tobac_zeile("'< " + te + " generated by utility", PROG_NAME +" V" & PROG_VERS)
  ausg += tobac_zeile("'< " + td + " erzeugt von", "")
  ausg += tobac_zeile("'< Generated at / Generierung am", FORMAT(NOW,FormDa) + ", " + FORMAT(NOW,FormZe))
END SUB

'*
'*  generating comments code for modules
'*  Erzeugt Kommentar-Quelltext für Module
'***********************************************************************
SUB tobac_modul()
  ausg += tobac_C_tre
  ausg += tobac_zeile("'< Main/Haupt Program name: " + _OUT_.PNam + SufBas, "")
  IF    LEN(_OUT_.Auth) THEN ausg += tobac_zeile("'< Author:  " & _OUT_.Auth, "")
  IF   LEN(_OUT_.Mail) THEN ausg += tobac_zeile("'<  Email:  " & _OUT_.Mail, "")
  IF LEN(_OUT_.Site) THEN ausg += tobac_zeile("'<    WWW:  " & _OUT_.Site, "")
END SUB

'*
'*  inserts a license file into output
'*  Fuegt in die Code-Zeilen eine Lizenz
'***********************************************************************
SUB fill_code_Lizense(BYVAL Rand AS STRING)
  IF ProgramLicense >= UBOUND(Licenses) THEN
    ausg += rand & "Put your license here/Lizenz hier einfuegen." & NL
    EXIT SUB
  END IF
  DIM AS INTEGER fnr = FREEFILE
  DIM AS STRING buff = MyDir & OrdData & SLASH & Licenses(ProgramLicense)
  DIM AS STRING o = LTRIM(Rand)
  IF OPEN (buff FOR INPUT AS #fnr) THEN
    rausrot(NL & Tmsg(56) & buff & NL)
  ELSE
    LINE INPUT #fnr, buff ' This will get the license's name
    WHILE NOT EOF(fnr)
      LINE INPUT #fnr, buff
      IF ASC(o) = ASC("'") THEN ' comment / Kommentar
        ausg += tobac_zeile(Rand & buff, "")
      ELSE
        IF LEN(buff) THEN ausg += Rand & buff
        ausg += NL
      END IF
    WEND : CLOSE #fnr
  END IF
END SUB

'*
'*  inserts the .desc file into output
'*  Fuegt in die Code-Zeilen die Beschreibung .desc ein
'***********************************************************************
SUB fill_code_Desc(BYVAL Rand AS STRING)
  DIM AS STRING buff = _INI_.Path & SLASH & _OUT_.PNam & SufDes
  IF NOT FILEEXISTS(buff) THEN EXIT SUB
  DIM AS INTEGER fnr = FREEFILE
  DIM AS STRING o = LTRIM(Rand)
  IF OPEN (buff FOR INPUT AS #fnr) THEN rausrot(NL & Tmsg(56) & buff & NL)
  WHILE NOT EOF(fnr)
    LINE INPUT #fnr, buff
    IF ASC(o) = ASC("'") THEN ' comment / Kommentar
      ausg += tobac_zeile(Rand & buff, "")
    ELSE
      IF LEN(buff) THEN ausg += Rand & buff
      ausg += NL
    END IF
  WEND : CLOSE #fnr
END SUB

'*
'*  generating code for .bas program shell
'*  Erzeugt Quelltext für den .bas-Quelltextrahmen
'***********************************************************************
SUB fill_code_bas()
DIM AS INTEGER i
  tobac_top("main program","Hauptprogramm")
  ausg += tobac_C_tre
  ausg += tobac_zeile("'< Program info:", "")
  ausg += tobac_zeile(BasName & _OUT_.PNam & """ '", "")
  ausg += tobac_zeile(BasDesc & _OUT_.Desc & """ '", "")
  ausg += tobac_zeile(BasVers & _OUT_.Vers & """ '", "")
  ausg += tobac_zeile(BasYear & _OUT_.Jahr & """ '", "")
  ausg += tobac_zeile(BasAuth & _OUT_.Auth & """ '", "")
  ausg += tobac_zeile(BasMail & _OUT_.Mail & """ '", "")
  ausg += tobac_zeile(BasSite & _OUT_.Site & """ '", "")
  ausg += tobac_zeile("'<", "")
  ausg += tobac_zeile("'< Description / Beschreibung:", "")
  ausg += tobac_zeile("'<", "")
  fill_code_Desc     ("'< ")
  ausg += tobac_zeile("'<", "")
  ausg += tobac_zeile("'< License / Lizenz:", "")
  ausg += tobac_zeile("'<", "")
  fill_code_Lizense  ("'< ")
  ausg += tobac_zeile("'<", "")
  ausg += tobac_C_tre
  ausg += tobac_zeile("'< Please prefer GNU GENERAL PUBLIC LICENSE to support open software.", "")
  ausg += tobac_zeile("'< For more information please visit:", "http://www.fsf.org")
  ausg += tobac_zeile("'<", "")
  ausg += tobac_zeile("'< Bitte bevorzugen Sie die GNU GENERAL PUBLIC LICENSE und", "")
  ausg += tobac_zeile("'< unterstuetzen Sie mit Ihrem Programm die freie Software", "")
  ausg += tobac_zeile("'< Mehr Informationen finden Sie unter:", "http://www.fsf.org")
  ausg += tobac_C_tre
  ausg += tobac_zeile("'<  GTK+tobac:", "general init / Allgemeine Initialisierungen")
  IF _INI_.Old THEN
    ausg += tobac_zeile(BasOld, "for old versions / alte GTK+ Version")
  END IF
  ausg += tobac_zeile("    #INCLUDE ""gtk/GTK-2.22.0_TJF.bi"" '", "GTK+library / GTK+ Bibliothek")
  ausg += tobac_zeile("    gtk_init(@__FB_ARGC__, @__FB_ARGV__) '", "start GKT / GTK starten")
  ausg += tobac_zeile("'<  GTK+tobac:", "end block / Blockende")
  ausg += tobac_C_end
  ausg += NL & NL
  ausg += "' place your source code here / eigenen Quelltext hier einfuegen" & NL
  ausg += Tmsg(0) & NL
  ausg += NL & NL
  ausg += tobac_C_sta
  ausg += tobac_zeile("'<  GTK+tobac:", "load GTK stuff / GTK Anbindung")
  DIM AS STRING nam, tob = _OUT_.PNam + SufTobac
  IF _INI_.Toba THEN tob = OrdTobac + slash + tob
  ausg += tobac_zeile("    #INCLUDE """ + tob + """ '", "callbacks + GUI-XML")
  ausg += tobac_zeile("'<  GTK+tobac:", "end block / Blockende")
  ausg += tobac_C_end
  ausg += NL & NL
  ausg += "' here widgets are known, place your source code here" & NL
  ausg += "' hier sind die Widgets bekannt, eigenen Quelltext einfuegen" & NL
  ausg += Tmsg(0) & NL
  ausg += NL & NL
  ausg += tobac_C_sta
  ausg += tobac_zeile("'<  GTK+tobac:", "run GTK main, then end / GTK Hauptschleife, dann Ende")
  IF LEN(_OUT_.TyNa) THEN
    tob = _OUT_.TyNa & "." & BasXml
    nam = _OUT_.TyNa & "." & UsNa(0)
  ELSE
    tob = BasXml
    nam = UsNa(0)
  END IF
  IF _OUT_.Suff <> SufBui THEN
    ausg += tobac_zeile("    glade_xml_signal_autoconnect(" & tob & ") '", "callbacks anbinden")
  ELSE
    ausg += tobac_zeile("    gtk_builder_connect_signals(" & tob & ", 0) '", "callbacks anbinden")
    nam = "GTK_WIDGET(" & nam & ")"
  END IF
  ausg += tobac_zeile("    gtk_widget_show_all(" & nam & ") '", "Hauptfenster darstellen")
  ausg += tobac_zeile("    gtk_main() '", "main loop / Hauptschleife")
  ausg += tobac_zeile("    g_object_unref(" & tob & ") '", "dereference / Referenz abbauen")
  ausg += tobac_zeile("'<  GTK+tobac:", "end block / Blockende")
  ausg += tobac_C_end
  ausg += NL & NL
  ausg += "' you may unref files here / ggf. Dateien hier schliessen" & NL
  ausg += NL & NL
  ausg += "END 0 ' finish with return code 0 / Ende mit Returncode 0" & NL
END SUB

'*
'*  generating code for defining the references
'*  Füllt Quelltext mit Definitionen fuer die Referenzen
'***********************************************************************
SUB fill_code_tobdef()
  DIM AS STRING widtyp, xmltyp
  IF _OUT_.Suff = SufBui THEN
    widtyp = "GObject"
    xmltyp = "GtkBuilder"
  ELSE
    widtyp = "GtkWidget"
    xmltyp = "GladeXML"
  END IF

  IF LEN(_OUT_.TyNa) THEN '                      declare PTR for Widgets
    ausg += "TYPE " & _OUT_.TyNa & "Daten" & NL
    IF _INI_.UiIn THEN ausg += "  AS STRING " & BasGui & NL
    ausg += "  AS " & xmltyp & " PTR " & BasXml & NL
    ausg += "  AS " & widtyp & " PTR _" & NL
  ELSE
    IF _INI_.UiIn THEN ausg += "DIM AS STRING " & BasGui & NL
    ausg += "DIM SHARED AS " & xmltyp & " PTR " & BasXml & NL
    ausg += "DIM SHARED AS " & widtyp & " PTR _" & NL
  END IF
  DIM AS STRING zeile = "  "
  FOR i AS INTEGER = 0 TO AzUN - 1
    IF LEN(zeile) > 70 THEN ausg += zeile & " _" & NL : zeile = "  "
    zeile += UsNa(i) & ", "
  NEXT i : ausg += RTRIM(zeile, ANY " ,") & NL
  IF LEN(_OUT_.TyNa) THEN
    ausg += "END TYPE" & NL
    ausg += "DIM SHARED AS " & _OUT_.TyNa & "Daten " & _OUT_.TyNa & NL
  END IF : ausg += NL
END SUB

'*
'*  generating code for reference PTRs
'*  Füllt Quelltext mit den PTR Referenzen
'***********************************************************************
SUB fill_code_tobref()
  DIM AS STRING o, func
  IF _OUT_.Suff = SufBui THEN
    func = "gtk_builder_get_object("
  ELSE
    func = "glade_xml_get_widget("
  END IF
  IF LEN(_OUT_.TyNa) THEN
    o = "  ."
    func += "."
    ausg += "WITH " & _OUT_.TyNa & NL
  END iF
  FOR i AS INTEGER = 0 TO AzUN - 1
    ausg += o & UsNa(i) + " = " & func & BasXml &", """ & UsNa(i) + """)" & NL
  NEXT i
  IF LEN(_OUT_.TyNa) THEN ausg += "END WITH" & NL
END SUB

'*
'*  generating code for Glade in tobac modul
'*  Füllt Quelltext für die Verwendung von Glade im tobac-Modul
'***********************************************************************
SUB fill_code_glade()
  ausg += "EXTERN ""C"" LIB ""glade-2.0""" & NL & NL
  ausg += "TYPE GladeXML AS _GladeXML" & NL
  ausg += "TYPE GladeXMLPrivate AS _GladeXMLPrivate" & NL & NL
  ausg += "TYPE _GladeXML" & NL
  ausg += "  parent AS GObject" & NL
  ausg += "  filename AS ZSTRING PTR" & NL
  ausg += "  priv AS GladeXMLPrivate PTR" & NL
  ausg += "END TYPE" & NL & NL
  IF _INI_.UiIn THEN
    ausg += "DECLARE FUNCTION glade_xml_new_from_buffer CDECL(BYVAL AS ZSTRING PTR, BYVAL AS INTEGER, BYVAL AS ZSTRING PTR, BYVAL AS ZSTRING PTR) AS GladeXML PTR" & NL
  ELSE
    ausg += "DECLARE FUNCTION glade_xml_new CDECL(BYVAL AS ZSTRING PTR, BYVAL AS ZSTRING PTR, BYVAL AS ZSTRING PTR) AS GladeXML PTR" & NL
  END IF
  ausg += "DECLARE FUNCTION glade_xml_get_widget CDECL(BYVAL AS GladeXML PTR, BYVAL AS ZSTRING PTR) AS GtkWidget PTR" & NL
  ausg += "DECLARE SUB glade_xml_signal_autoconnect CDECL(BYVAL AS GladeXML PTR)" & NL & NL
  ausg += "END EXTERN" & NL & NL
  fill_code_tobdef()
  DIM AS STRING x = BasXml, y = BasGui
  IF LEN(_OUT_.TyNa) THEN
    x = _OUT_.TyNa & "." & x
    y = _OUT_.TyNa & "." & y
  END IF
  IF _INI_.UiIn THEN
    ausg += "#INCLUDE """ + _OUT_.PNam + SufGui + """" & NL
    ausg += x & " = glade_xml_new_from_buffer(SADD(" & y & "), LEN(" & y & "), 0, 0)" & NL
  ELSE
    ausg += x & " = glade_xml_new(""" & _OUT_.PNam & SufGla & """, 0, 0)" & NL
  END IF : ausg += NL
  fill_code_tobref()
END SUB

'*
'*  generating code for GTKBuilder in tobac modul
'*  Füllt Quelltext für die Verwendung von GTKBuilder im tobac-Modul
'***********************************************************************
SUB fill_code_builder()
  ausg += "IF gtk_check_version("
  IF _INI_.Old THEN ausg += "2, 12, 0" ELSE ausg += "2, 22, 0"
  ausg += ") THEN" & NL
  ausg += "  ?""Fehler/Error (GTK-Version): Version zu alt""" & NL
  ausg += "  END -1" & NL
  ausg += "END IF" & NL & NL
  fill_code_tobdef()
  DIM AS STRING x = BasXml, y = BasGui
  IF LEN(_OUT_.TyNa) THEN
    x = _OUT_.TyNa & "." & x
    y = _OUT_.TyNa & "." & y
  END IF
  ausg += x & " = gtk_builder_new()" & NL & NL
  ausg += "SCOPE" & NL
  ausg += "  DIM AS GError PTR meld" & NL
  IF _INI_.UiIn THEN
    ausg += "  #INCLUDE """ & _OUT_.PNam & SufGui & """" & NL
    ausg += "  IF 0 = gtk_builder_add_from_string(" & x & ", SADD(" & y & "), LEN(" & y & "), @meld) THEN" & NL
  ELSE
    ausg += "  IF 0 = gtk_builder_add_from_file(" & x & ", """ & _OUT_.PNam & SufBui & """, @meld) THEN" & NL
  END IF
  ausg += "    WITH *meld" & NL
  ausg += "      ?""Fehler/Error (GTK-Builder):""" & NL
  ausg += "      ?*.message" & NL
  ausg += "    END WITH" & NL
  ausg += "    END -1" & NL
  ausg += "  END IF" & NL
  ausg += "END SCOPE" & NL & NL
  fill_code_tobref()
END SUB

'*
'*  generating code for tobac modul
'*  Füllt Quelltext für das tobac-Modul
'***********************************************************************
SUB fill_code_tobac()
  tobac_top("_tobac.bas modul","Modul _tobac.bas")
  tobac_modul()
  ausg += tobac_C_tre
  ausg += tobac_zeile("'< declaring names, callback SUBs, loading GUI-XML", "do not edit!")
  ausg += tobac_zeile("'< deklariert Namen, Callbacks, laedt GUI-XML", "nicht veraendern!")
  ausg += tobac_C_end & NL

  IF _OUT_.Suff = SufBui THEN
    fill_code_builder()
  ELSE
    fill_code_glade()
  END IF : ausg += NL

  FOR i AS INTEGER = 0 TO AzCB - 1 '                   Declare callbacks
    ausg += "#INCLUDE """ & MID(NaCB(i), 5) & SufBas & """" & NL
  NEXT i : ausg += NL
END SUB

'*
'*  translates double quotes (") into FreeBasic syntax, shortens long lines
'*  wandelt .UiIne Anfuehrungsz. in FreeBasic-Syntax, bricht ggf. lange Zeile um
'***********************************************************************
FUNCTION GuiCoding(BYVAL z AS STRING) AS STRING ' Anführungszeichen verdoppeln
  DIM AS INTEGER p = INSTR(z, CHR(34))
  WHILE p
    z = MID(z, 1, p) + CHR(34) + MID(z, p + 1)
    p = INSTR(p + 2, z, CHR(34))
  WEND : p = 240
  WHILE p < LEN(z)
    z = MID(z, 1, p) + """+_" + NL + """" + MID(z, p + 1)
    p += 240 : WHILE ASC(z, p) = ASC("""") : p -= 1 : WEND
  WEND : RETURN z
END FUNCTION

'*
'*  generating code for GUI modul (header only)
'*  Füllt die Code-Zeilen für das GUI-Modul (nur Kopf)
'***********************************************************************
SUB fill_code_gui(BYVAL FnBa AS INTEGER)
  DIM AS INTEGER fnr = FREEFILE
  DIM AS STRING zeile
  DIM AS ZSTRING PTR en
  IF _OUT_.Suff = SufBui THEN en = @"" ELSE en = @"+CHR(0)"
  tobac_top(SufGui & " modul","Modul " & SufGui)
  tobac_modul()
  ausg += tobac_C_tre
  ausg += tobac_zeile("'< loading GUI-XML-Data into memory", "do not edit!")
  ausg += tobac_zeile("'< liest GUI-XML-Daten in den Speicher", "nicht veraendern!")
  ausg += tobac_C_end & NL
  IF LEN(_OUT_.TyNa) THEN ausg += _OUT_.TyNa & "."
  ausg += "GUIstr =_" & NL
  PRINT #FnBa, ausg;
' appending .UiIne-file / .UiIne-Datei anhaengen
  IF OPEN (_OUT_.PaNa FOR INPUT AS #fnr) THEN
    rausrot(NL + Tmsg(33) + _OUT_.PaNa) ' Schreibfehler
  ELSE
    WHILE NOT EOF(fnr)
      LINE INPUT #fnr, zeile
      PRINT #FnBa, """" + GuiCoding(LTRIM(zeile)) + """";
      PRINT #FnBa, *IIF(EOF(fnr), en, @"+_")
    WEND : CLOSE #fnr
  END IF
END SUB

'*
'*  generating code for callback modul
'*  Füllt die Code-Zeilen für ein Callback-Modul
'***********************************************************************
SUB fill_code_callb(n AS STRING)
  DIM AS INTEGER leer = 4 + LEN(n)
  tobac_top("callback modul","callback-Modul")
  tobac_modul()
  ausg += tobac_C_tre
  ausg += tobac_zeile("'< callback SUB", "insert code!")
  ausg += tobac_zeile("'< Ereignis Unterprogramm", "Quelltext einfuegen!")
  ausg += tobac_C_end & NL
  ausg += genCB(n)
END SUB

'*
'*  create a simple readme (readme.txt)
'*  erzeugt readme.txt
'***********************************************************************
SUB fill_code_ReadMe()
  ausg  = NL
  ausg += "  " & _OUT_.PNam & " - " & _OUT_.Desc & NL
  ausg += "  Copyright (c) " & _OUT_.Jahr & " " & _OUT_.Auth & NL
  IF LEN(_OUT_.Mail) THEN ausg += "    Email: " & _OUT_.Mail & NL
  IF LEN(_OUT_.Site) THEN ausg += "  Website: " & _OUT_.Site & NL
  ausg += NL & NL & "License:" & NL & NL
  fill_code_Lizense("  ")
  ausg += NL & "Description:" & NL & NL
  fill_code_Desc("  ")
  ausg += NL & NL
END SUB

'*
'*  create the Geany project file (*.geany)
'*  erzeugt Geany-Projekt-Datei
'***********************************************************************
SUB fill_code_Geany(BYVAL p AS STRING)
  ausg  = NL
  ausg += "[indentation]" & NL
  ausg += "indent_width=2" & NL
  ausg += "indent_type=1" & NL
  ausg += "indent_hard_tab_width=8" & NL
  ausg += "detect_indent=false" & NL
  ausg += "indent_mode=2" & NL
  ausg += NL
  ausg += "[project]" & NL
  ausg += "name=" & _OUT_.PNam & NL
  ausg += "base_path=" & LEFT(p, LEN(p) - 1) & NL
  ausg += "make_in_base_path=false" & NL
  ausg += "description=" & _OUT_.Desc & NL
  DIM AS STRING a = "./" & _OUT_.PNam
  IF SLASH = "\" THEN a = _OUT_.PNam & ".exe"
  ausg += "run_cmd=" & a & NL
  ausg += NL
  ausg += "[files]" & NL
  ausg += "current_page=0" & NL
  ausg += "FILE_NAME_0=0;FreeBasic;0;16;1;1;1;" & p & _OUT_.PNam & ".bas;0" & NL
  'ausg += "FILE_NAME_1=0;FreeBasic;0;16;1;1;1;" & p & _OUT_.PNam & ".bi;0" & NL
END SUB

'*
'*  create create the FBIde project file (*.fbide.fbp)
'*  erzeugt FBIde-Projekt-Datei
'***********************************************************************
SUB fill_code_FbIde(BYVAL n AS STRING)
  ausg  = "[General]" & NL
  ausg += "Name=" & _OUT_.PNam & NL
  ausg += "Type=1" & NL
  ausg += "Lang=" & NL
  ausg += "Output=" & n & ".exe" & NL
  ausg += "OptionalParam=" & NL
  ausg += "MainModule=" & n & ".bas" & NL
  IF _INI_.Win THEN
    ausg += "ItemCount=2" & NL
  ELSE
    ausg += "ItemCount=3" & NL
  END IF
  ausg += "FolderCount=0" & NL
  ausg += "[Item_0]" & NL
  ausg += "Path=" & NL
  ausg += "File=" & n & ".bas" & NL
  ausg += "Compile=1" & NL
  ausg += "[Item_1]" & NL
  ausg += "Path=" & NL
  ausg += "File=" & n & ".bi" & NL
  ausg += "Compile=1" & NL
  IF _INI_.Win THEN
    ausg += "[Item_2]" & NL
    ausg += "Path=" & NL
    ausg += "File=" & n & ".rc" & NL
    ausg += "Compile=1" & NL
  END IF
  ausg += NL
END SUB

'*
'*  create FbEdit project file (*.fbp too!)
'*  erzeugt FbEdit-Projekt-Datei
'***********************************************************************
SUB fill_code_FbEdit(BYVAL n AS STRING)
  ausg  = "[Project]" & NL
  ausg += "Version=3" & NL
  ausg += "Description=" & _OUT_.Desc & NL
  ausg += "Api=fb (FreeBASIC)" & NL
  ausg += "[Make]" & NL
  ausg += "Current=1" & NL
  ausg += "1=Windows GUI,fbc -s gui" & NL
  ausg += "Recompile=2" & NL
  ausg += "Module=Module Build,fbc -c" & NL
  ausg += "[TabOrder]" & NL
  ausg += "TabOrder=1,2" & NL
  ausg += "[File]" & NL
  ausg += "1=" & n & ".bas" & NL
  ausg += "2=" & n & ".bi" & NL
  IF _INI_.Win THEN ausg += "3=" & n & ".rc" & NL
  ausg += "[BreakPoint]" & NL
  ausg += "1=" & NL
  ausg += "2=" & NL
  ausg += "[FileInfo]" & NL
  ausg += "1=0,0,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0" & NL
  ausg += "2=0,0,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0" & NL
  ausg += "3=0,0,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0" & NL
END SUB

'*
'*  create the JellyFB project file (*.jfp)
'*  erzeugt Jelly-Projekt-Datei
'***********************************************************************
SUB fill_code_Jelly(BYVAL n AS STRING)
  ausg  = "IDEmaximize= 1" & NL
  ausg += "KeywordCase=FREEBASIC (MIXED CASE)" & NL
  ausg += "Resolution= 1024, 768" & NL
  ausg += "CommandLine=" & NL
  ausg += "CompilerOptions=" & NL
  ausg += "ActiveFile=" & n & ".bas, 1, 1, 1" & NL
  ausg += "Filename=" & n & ".bi, 1, 1, 1" & NL
  IF _INI_.Win THEN ausg += "Filename=" & n & ".rc, 1, 1, 1" & NL
  ausg += "Compiler= 0" & NL
  ausg += "PrimaryFile=" & NL
  ausg += "LoadAllFunctions= 0" & NL
  ausg += "AutoCloseFunctionList= 0" & NL
  ausg += "UnSortFunctionList= 0" & NL & NL
END SUB

'*
'*  create the Win32 RC file (*.rc)
'*  erzeugt  Win32 RC Datei
'***********************************************************************
SUB fill_code_WinRc(BYVAL n AS STRING)
  ausg  = "#define IDR_VERSION 1" & !"\r\n" & NL
  ausg += "#define IDI_PROGICON 100" & !"\r\n" & NL
  ausg += !"\r\n" & NL
  ausg += "IDR_VERSION VERSIONINFO" & !"\r\n" & NL
  ausg += "FILEVERSION 1,0,0,0" & !"\r\n" & NL
  ausg += "PRODUCTVERSION 1,0,0,0" & !"\r\n" & NL
  ausg += "FILEOS 0x00000004" & !"\r\n" & NL
  ausg += "FILETYPE 0x00000001" & !"\r\n" & NL
  ausg += "BEGIN" & !"\r\n" & NL
  ausg += "  BLOCK ""StringFileInfo""" & !"\r\n" & NL
  ausg += "  BEGIN" & !"\r\n" & NL
  ausg += "    BLOCK ""040904E4""" & !"\r\n" & NL
  ausg += "    BEGIN" & !"\r\n" & NL
  ausg += "      VALUE ""FileVersion"", """ & _OUT_.Vers & !"\\0""" & !"\r\n" & NL ' ToDo:
  ausg += "      VALUE ""ProductVersion"", """ & _OUT_.Vers & !"\\0""" & !"\r\n" & NL
  ausg += "      VALUE ""CompanyName"", """ & _OUT_.Auth & !"\\0""" & !"\r\n" & NL
  ausg += "      VALUE ""FileDescription"", """ & _OUT_.PNam & !"\\0""" & !"\r\n" & NL
  ausg += "      VALUE ""InternalName"", """ & n & !"\\0""" & !"\r\n" & NL
  ausg += "      VALUE ""LegalCopyright"", ""Copyright (c) " & _OUT_.Jahr & " " & _OUT_.Auth & !"\\0""" & !"\r\n" & NL
  ausg += "      VALUE ""OriginalFilename"", """ & n & !".exe\\0""" & !"\r\n" & NL
  ausg += "      VALUE ""ProductName"", """ & _OUT_.PNam & !"\\0""" & !"\r\n" & NL
  ausg += "    END" & !"\r\n" & NL
  ausg += "  END" & !"\r\n" & NL
  ausg += "  BLOCK ""VarFileInfo""" & !"\r\n" & NL
  ausg += "  BEGIN" & !"\r\n" & NL
  ausg += "    VALUE ""Translation"", 0x0409, 0x04E4" & !"\r\n" & NL
  ausg += "  END" & !"\r\n" & NL
  ausg += "END" & !"\r\n" & NL
  IF _INI_.Rc THEN
    ausg += "" & !"\r\n" & "IDI_PROGICON ICON DISCARDABLE """ _
                                            & n & ".ico""" & !"\r\n" & NL
  END IF
END SUB

'*
'*  create the makefile (makefile)
'*  erzeugt makefile
'***********************************************************************
SUB fill_code_make(BYVAL n AS STRING)
    ausg  = "#" & NL
    ausg += "# " & _OUT_.PNam & " - " & _OUT_.Desc & NL
    ausg += "# Copyright (C) " & _OUT_.Jahr & " " & _OUT_.Auth & NL
    IF   LEN(_OUT_.Mail) THEN ausg += "# Email: " & _OUT_.Mail & NL
    IF LEN(_OUT_.Site) THEN ausg += "# Website: " & _OUT_.Site & NL
    ausg += "#" & NL
    fill_code_Lizense("# ")
    ausg += "#" & NL
    ausg += NL & NL
    ausg += !"# Note:" & NL
    ausg += !"# Set TARGET to dos, w32, linux, or cygwin -- if not defined, it will" & NL
    ausg += !"# be the same as HOST, if the later could be guessed" & NL
    ausg += NL
    ausg += !"_OUT_.PName = " & n & NL
    ausg += !"progversion = " & _OUT_.Vers & NL
    ausg += !"srcdir = $(VPATH)" & NL
    ausg += !"prefix = /usr/local" & NL
    ausg += !"exec_prefix = $(prefix)" & NL
    ausg += !"bindir = $(exec_prefix)/bin" & NL
    ausg += !"libdir = $(exec_prefix)/lib" & NL
    ausg += !"datarootdir = $(prefix)/share" & NL
    ausg += !"datadir = $(datarootdir)" & NL
    ausg += !"docdir = $(datarootdir)/doc/$(_OUT_.PName)" & NL
    ausg += !"menudir = $(datadir)/applications" & NL
    ausg += !"icondir = $(datadir)/pixmaps" & NL
    ausg += !"SHELL = /bin/sh" & NL
    ausg += !"DISTNAME = $(_OUT_.PName)-$(progversion)" & NL
    ausg += !"INSTALL = install" & NL
    ausg += !"INSTALL_PROGRAM = $(INSTALL) -p -m 755" & NL
    ausg += !"INSTALL_DATA = $(INSTALL) -p -m 644" & NL
    ausg += !"MKDIR_P = mkdir -p" & NL
    ausg += NL
    ausg += !"HOST :=" & NL
    ausg += !"ifeq ($(OS),Windows_NT)" & NL
    ausg += !"\tifeq ($(OSTYPE),cygwin)" & NL
    ausg += !"\t\tHOST := cygwin" & NL
    ausg += !"\telse" & NL
    ausg += !"\t\tHOST := w32" & NL
    ausg += !"\tendif" & NL
    ausg += !"else" & NL
    ausg += !"\tifdef WINDIR" & NL
    ausg += !"\t\tHOST := w32" & NL
    ausg += !"\telse" & NL
    ausg += !"\t\tifdef windir" & NL
    ausg += !"\t\t\tHOST := w32" & NL
    ausg += !"\t\telse" & NL
    ausg += !"\t\t\tifdef HOME" & NL
    ausg += !"\t\t\t\tHOST := linux" & NL
    ausg += !"\t\t\tendif" & NL
    ausg += !"\t\tendif" & NL
    ausg += !"\tendif" & NL
    ausg += !"endif" & NL
    ausg += NL
    ausg += !"ifndef TARGET" & NL
    ausg += !"\tifndef HOST" & NL
    ausg += !"\t\tCHECKHOST_MSG := $(error Error: TARGET not defined and HOST couldn't be guessed)" & NL
    ausg += !"\telse" & NL
    ausg += !"\t\tCHECKHOST_MSG :=" & NL
    ausg += !"\tendif" & NL
    ausg += !"\tTARGET := $(HOST)" & NL
    ausg += !"endif" & NL
    ausg += NL
    ausg += !"OBJPATH = ." & NL
    ausg += NL
    ausg += !"FBC = fbc" & NL
    ausg += NL
    ausg += !"MAIN := " & n & NL
    ausg += NL
    ausg += !"SRCS := $(MAIN).bas" & NL
    ausg += NL
    ausg += !"HDRS := $(wildcard *.bi)" & NL
    ausg += NL
    ausg += !"DATS := $(MAIN).UiIne" & NL
    ausg += NL
    ausg += !"DOCS := Makefile" & NL
    WITH _INI_
      IF .ReadMe THEN ausg += !"DOCS += README" & NL
      ausg += NL
      IF .Win THEN
        ausg += !"W32EXTS := $(MAIN).rc" & NL
        IF .Rc THEN ausg += !"W32EXTS += $(MAIN).ico" & NL
      ELSE
        ausg += !"W32EXTS := " & NL
      END IF
      IF .FbIde THEN ausg += !"W32EXTS += $(MAIN).fbide.fbp" & NL
      IF .FbEdit THEN
        ausg += !"W32EXTS += $(MAIN).fbp" & NL
      END IF
      IF .Jelly THEN ausg += !"W32EXTS += $(MAIN).jfp" & NL
      ausg += !"LINEXTS := " & NL
      ausg += !"EXTS := $(W32EXTS) $(LINEXTS)" & NL
      IF .Geany THEN ausg += !"EXTS += $(MAIN).geany" & NL
    END WITH
    ausg += NL
    ausg += !"FBCFLAGS = -w all -exx" & NL
    ausg += NL
    ausg += !"FBCFLAGS_ALL = -export $(FBCFLAGS)" & NL
    ausg += NL
    ausg += !"DEFS =" & NL
    ausg += NL
    ausg += !"RCS =" & NL
    ausg += NL
    ausg += !"ifeq ($(TARGET),w32)" & NL
    ausg += !"  FBCFLAGS += -s gui" & NL
    ausg += !"  RCS += $(MAIN).rc" & NL
    ausg += !"  APP := $(MAIN).exe" & NL
    ausg += !"  HOSTEXTS := $(W32EXTS)" & NL
    ausg += !"elseifeq ($(TARGET),cygwin)" & NL
    ausg += !"  FBCFLAGS += -s gui" & NL
    ausg += !"  RCS += $(MAIN).rc" & NL
    ausg += !"  APP := $(MAIN).exe" & NL
    ausg += !"  HOSTEXTS := $(W32EXTS)" & NL
    ausg += !"else" & NL
    ausg += !"  APP := $(MAIN)" & NL
    ausg += !"  HOSTEXTS := $(LINEXTS)" & NL
    ausg += !"endif" & NL
    ausg += NL
    ausg += !"ifdef DEBUG" & NL
    ausg += !"  FBCFLAGS += -g" & NL
    ausg += !"endif" & NL
    ausg += NL
    ausg += !"OBJS = $(patsubst %.bas,$(OBJPATH)/%.o,$(SRCS))" & NL
    ausg += NL
    ausg += !"##########################" & NL
    ausg += NL
    ausg += !".SUFFIXES:" & NL
    ausg += !".SUFFIXES: .bas" & NL
    ausg += NL
    ausg += !"VPATH = ." & NL
    ausg += NL
    ausg += !"%.o : %.bas" & NL
    ausg += !"\t$(FBC) $(FBCFLAGS_ALL) -m $(MAIN) $(DEFS) -c $< -o $@" & NL
    ausg += NL
    ausg += !"##########################" & NL
    ausg += NL
    ausg += !"all : $(APP)" & NL
    ausg += NL
    ausg += !"$(APP) : $(OBJS)" & NL
    ausg += !"\t$(FBC) $(FBCFLAGS_ALL) $(OBJS) $(RCS) -x $(APP)" & NL
    ausg += NL
    ausg += n & ".o : " & n & ".bi" & NL
    ausg += NL
    ausg += !".PHONY : clean" & NL
    ausg += !"clean-objs :" & NL
    ausg += !"\t-rm -f $(OBJS) $(MAIN).obj" & NL
    ausg += NL
    ausg += !"clean : clean-objs" & NL
    ausg += !"\t-rm -f $(APP)" & NL
    ausg += NL
    ausg += !"distclean : clean" & NL
    ausg += !"\t-rm -f *.gz *.bz2 *.zip" & NL
    ausg += NL
    ausg += !"##########################" & NL
    ausg += NL
    ausg += !"install : all $(DATS)" & NL
    ausg += !"\ttest -z ""$(DESTDIR)$(bindir)"" || $(MKDIR_P) ""$(DESTDIR)$(bindir)""" & NL
    ausg += !"\t$(INSTALL_PROGRAM) $(srcdir)/$(APP) ""$(DESTDIR)$(bindir)/$(APP)""" & NL
    ausg += !"\ttest -z ""$(DESTDIR)$(datadir)/$(_OUT_.PName)"" || $(MKDIR_P) ""$(DESTDIR)$(datadir)/$(_OUT_.PName)""" & NL
    ausg += !"\t$(INSTALL_DATA) $(srcdir)/$(MAIN).UiIne ""$(DESTDIR)$(datadir)/$(_OUT_.PName)/$(MAIN).UiIne""" & NL
    ausg += NL
    ausg += !"uninstall :" & NL
    ausg += !"\t-rm -f $(DESTDIR)$(bindir)/$(_OUT_.PName)" & NL
    ausg += !"\t-rm -f -r $(DESTDIR)$(datadir)/$(_OUT_.PName)" & NL
    ausg += NL
    ausg += !"dist-gz : $(SRCS) $(HDRS) $(DATS) $(DOCS) $(EXTS)" & NL
    ausg += !"\tln -sf $(srcdir) $(DISTNAME)" & NL
    ausg += !"\ttar -czvf $(DISTNAME).tar.gz \\" & NL
    ausg += !"\t  $(DISTNAME)/*.bas \\" & NL
    ausg += !"\t  $(DISTNAME)/*.bi \\" & NL
    ausg += !"\t  $(addprefix $(DISTNAME)/,$(DATS)) \\" & NL
    ausg += !"\t  $(addprefix $(DISTNAME)/,$(DOCS)) \\" & NL
    ausg += !"\t  $(addprefix $(DISTNAME)/,$(EXTS))" & NL
    ausg += !"\trm -f $(DISTNAME)" & NL
    ausg += NL
    ausg += !"dist-bz2 : $(SRCS) $(HDRS) $(DATS) $(DOCS) $(EXTS)" & NL
    ausg += !"\tln -sf $(srcdir) $(DISTNAME)" & NL
    ausg += !"\ttar -cvf $(DISTNAME).tar \\" & NL
    ausg += !"\t  $(DISTNAME)/*.bas \\" & NL
    ausg += !"\t  $(DISTNAME)/*.bi \\" & NL
    ausg += !"\t  $(addprefix $(DISTNAME)/,$(DATS)) \\" & NL
    ausg += !"\t  $(addprefix $(DISTNAME)/,$(DOCS)) \\" & NL
    ausg += !"\t  $(addprefix $(DISTNAME)/,$(EXTS))" & NL
    ausg += !"\trm -f $(DISTNAME)" & NL
    ausg += !"\tbzip2 -v -9 $(DISTNAME).tar" & NL
    ausg += NL
    ausg += !"dist-zip : $(SRCS) $(HDRS) $(DATS) $(DOCS) $(EXTS) $(LIBS)" & NL
    ausg += !"\tln -sf $(srcdir) $(DISTNAME)" & NL
    ausg += !"\tzip -v -9 -r $(DISTNAME).zip \\" & NL
    ausg += !"\t  $(DISTNAME)/*.bas \\" & NL
    ausg += !"\t  $(DISTNAME)/*.bi \\" & NL
    ausg += !"\t  $(addprefix $(DISTNAME)/,$(DATS)) \\" & NL
    ausg += !"\t  $(addprefix $(DISTNAME)/,$(DOCS)) \\" & NL
    ausg += !"\t  $(addprefix $(DISTNAME)/,$(EXTS))" & NL
    ausg += !"\trm -f $(DISTNAME)" & NL
    ausg += NL
    ausg += !"dist-gz-bin : $(APP) $(DATS) $(DOCS) $(HOSTLIBS)" & NL
    ausg += !"\tln -sf $(srcdir) $(DISTNAME)" & NL
    ausg += !"\ttar -cvzf $(DISTNAME)_$(HOST).tar.gz \\" & NL
    ausg += !"\t  $(DISTNAME)/$(APP) \\" & NL
    ausg += !"\t  $(addprefix $(DISTNAME)/,$(DATS)) \\" & NL
    ausg += !"\t  $(addprefix $(DISTNAME)/,$(DOCS))" & NL
    ausg += !"\trm -f $(DISTNAME)" & NL
    ausg += NL
    ausg += !"dist-bz2-bin : $(APP) $(DATS) $(DOCS) $(HOSTLIBS)" & NL
    ausg += !"\tln -sf $(srcdir) $(DISTNAME)" & NL
    ausg += !"\ttar -cvf $(DISTNAME).tar \\" & NL
    ausg += !"\t  $(DISTNAME)/$(APP) \\" & NL
    ausg += !"\t  $(addprefix $(DISTNAME)/,$(DATS)) \\" & NL
    ausg += !"\t  $(addprefix $(DISTNAME)/,$(DOCS))" & NL
    ausg += !"\trm -f $(DISTNAME)" & NL
    ausg += !"\tbzip2 -v -9 $(DISTNAME).tar" & NL
    ausg += NL
    ausg += !"dist-zip-bin : $(APP) $(DATS) $(DOCS)" & NL
    ausg += !"\tln -sf $(srcdir) $(DISTNAME)" & NL
    ausg += !"\tzip -v -9 -r $(DISTNAME)_$(HOST).zip \\" & NL
    ausg += !"\t  $(DISTNAME)/$(APP) \\" & NL
    ausg += !"\t  $(addprefix $(DISTNAME)/,$(DATS)) \\" & NL
    ausg += !"\t  $(addprefix $(DISTNAME)/,$(DOCS))" & NL
    ausg += !"\trm -f $(DISTNAME)" & NL
    ausg += NL
    ausg += !"dist : dist-gz" & NL
    ausg += NL
    ausg += !"dist-all : dist-gz dist-bz2 dist-zip dist-gz-bin dist-bz2-bin dist-zip-bin" & NL
    ausg += NL
END SUB
