'*
'*  if needed: converting UTF-8 for DOS output (for console window)
'*  Wenn nötig: UTF-8 in DOS-ANSI konvertieren (fuer DOS-Konsole)
'***********************************************************************
FUNCTION DosTXT(t AS STRING) AS STRING
  IF slash="/" THEN RETURN t : EXIT FUNCTION
  DIM AS INTEGER p, i = 0
  WHILE i < LEN(t)
    IF t[i] = ASC(ConvUTF) THEN
      i += 1 : p = INSTR(ConvUTF, MID(t, i, 2))
      IF p THEN
        p = p SHR 1 + 1
        t = MID(t, 1, i - 1) + MID(ConvDOS, p, 1) + MID(t, i + 2)
      END IF
    END IF : i += 1
  WEND : RETURN t
END FUNCTION

'*
'*  translating filename to UTF8
'*  wandelt Dateiname in UTF8 zur Anzeige
'***********************************************************************
FUNCTION filename_to_utf8(BYVAL file AS STRING) AS STRING
  DIM AS ZSTRING PTR p
  DIM AS gsize bytes_written
  p = g_filename_to_utf8(file, -1, NULL, @bytes_written, NULL)
  DIM AS STRING r = *p
  g_free(p)
  RETURN r
END FUNCTION

'*
'*  clering/writing lines in different color to text buffer or consol window
'*  Ausgabe/löschen von Zeichen unterschiedlicher Farbe in Textfeld oder Konsole
'***********************************************************************
SUB rausclr(BYVAL t AS STRING)
  IF NoGUI THEN COLOR 14,0: PRINT DosTXT(t);: EXIT SUB
  ' notebook init / Karteireiter setzen
  gtk_notebook_set_current_page(GTK_NOTEBOOK(NotMain), 1)
  gtk_text_buffer_set_text(buffer,"",0)
  gtk_text_buffer_get_iter_at_offset(buffer, @Iter, 0)
  gtk_text_buffer_insert_with_tags_by_name(buffer,@Iter,t,-1,"bold",NULL)
END SUB
SUB raus(BYVAL t AS STRING)
  IF NoGUI THEN COLOR 15,0: PRINT DosTXT(t);: EXIT SUB
  gtk_text_buffer_insert_with_tags_by_name(buffer,@Iter,t,-1,NULL)
  DIM AS GtkTextMark PTR lp = gtk_text_buffer_create_mark (buffer, "last_pos", @Iter, FALSE)
  gtk_text_view_scroll_mark_onscreen (gtk_text_view(TeVMessage), lp)
  gtk_text_buffer_delete_mark (buffer, lp)
END SUB
SUB rausrot(BYVAL t AS STRING)
  IF NoGUI THEN COLOR 12,0: PRINT DosTXT(t);: EXIT SUB
  gtk_text_buffer_insert_with_tags_by_name(buffer,@Iter,t,-1,"red_fg",NULL)
END SUB
SUB rausblau(BYVAL t AS STRING)
  IF NoGUI THEN COLOR 11,0: PRINT DosTXT(t);: EXIT SUB
  gtk_text_buffer_insert_with_tags_by_name(buffer,@Iter,t,-1,"blue_fg",NULL)
END SUB

SUB FileDa(BYVAL p AS STRING, BYVAL n AS STRING, BYVAL e AS STRING)
  DIM AS STRING a = filename_to_utf8(n + e)
  IF FILEEXISTS(p+n+e) THEN
    raus(Tmsg(16)+": ") : rausblau(a & NL)
  ELSE
    raus(Tmsg(17)+": ") : rausrot(a & NL)
  END IF
END SUB
SUB DataDa(BYVAL t AS STRING, BYVAL n AS INTEGER, BYVAL z AS STRING, BYVAL f AS STRING)
  raus(t) : IF n=0 THEN raus(STR(n) & NL) : EXIT SUB
  IF f = "b" THEN rausblau(STR(n)) ELSE rausrot(STR(n))
  raus(z + NL)
END SUB

'*
'*  asking a question and waiting for response (modal)
'*  Frage ausgeben und modal auf Antwort warten
'***********************************************************************
FUNCTION Antwort(BYVAL f AS STRING, _
                 BYVAL b1 AS STRING, _
                 BYVAL b2 AS STRING, _
                 BYVAL b3 AS STRING) AS INTEGER
  IF NoGUI THEN
    DIM AS STRING  r = "", t = f + " " + b1 + " | " + b2 + " | " + b3
    DIM AS INTEGER a = 1, e = INSTR(t, "_")
    WHILE e
      raus(MID(t, a, e-a)) : rausrot(MID(t, e+1, 1))
      r += LCASE(MID(t, e+1, 1))
      a = e + 2 : e = INSTR(a, t, "_")
    WEND
    raus(MID(t, a))
    WHILE LEN(INKEY) : WEND ' empty keybord buffer / Tastaturpuffer leeren
    DO
      SLEEP : a = INSTR(r, LCASE(INKEY))
    LOOP UNTIL a : RETURN a
  ELSE ' show dialob box / Dialogbox anzeigen
    DIM AS INTEGER Antw
    DIM AS GtkWindow PTR parent = gtk_window(win_main)
    DIM AS GtkWidget PTR dialog = gtk_dialog_new_with_buttons (f,_
             parent, GTK_DIALOG_MODAL OR GTK_DIALOG_DESTROY_WITH_PARENT,_
             b1, 1, b2, 2, b3, 3, NULL)
    gtk_window_set_position (GTK_WINDOW(dialog), GTK_WIN_POS_MOUSE)
    Antw = gtk_dialog_run(GTK_DIALOG(dialog))
    gtk_widget_destroy(dialog) : RETURN Antw
  END IF
END FUNCTION

