'*
'*  Defining variables for language change
'*  Definiert Variablen fuer die Sprachumstellung
'***********************************************************************
ENUM LanguageChangeTypen
  GUI_MenuItem
  GUI_ToolTip
  GUI_ToolButton
  GUI_Label
  GUI_LabFrame
  GUI_Button
END ENUM

TYPE LanguageChange
  AS INTEGER     Typ
  AS GObject PTR Obj
  AS ZSTRING PTR Tex
END TYPE
DIM SHARED AS LanguageChange LaCha(55)


'*
'*  Defining message text for english language
'*  Definiert die Texte fuer englische Kommunikation
'***********************************************************************
SUB set_leng()
  DIM AS INTEGER i = 0
  i += 1: Thelp(i) = "Short help (for details look at '" + PROG_NAME + "_ReadMe.txt')" & NL & NL
  i += 1: Thelp(i) = "Synopsis: " + PROG_NAME + " >PATH" + SLASH + "FILE<.[ui|glade] -options" & NL & NL
  i += 1: Thelp(i) = PROG_NAME + " runs through the steps" & NL
  i += 1: Thelp(i) = "1.) load GUI-XML-file and analyse" & NL
  i += 1: Thelp(i) = "2.) write code files (can be omitted by -n or -N)" & NL
  i += 1: Thelp(i) = "3.) delete unneeded files (can be choosen by -a or -A)" & NL & NL
  i += 1: Thelp(i) = "If no regular file is specified the GUI will start." & NL & NL
  i += 1: Thelp(i) = "Options (use minus all times, separated by space):" & NL
  i += 1: Thelp(i) = "-h help (print this text and end)" & NL
  i += 1: Thelp(i) = "-a do funktion clean up, confirm deleting" & NL
  i += 1: Thelp(i) = "-A do funktion clean up, delete without confirmation" & NL
  i += 1: Thelp(i) = "-i include GUI-XML-file in code (for final version)" & NL
  i += 1: Thelp(i) = "-l specify language (currently 'en' {default='de'})" & NL
  i += 1: Thelp(i) = "-n NoAction: analyse file, confirm code sketching" & NL
  i += 1: Thelp(i) = "-N NoAction: analyse file, no code sketching at all" & NL
  i += 1: Thelp(i) = "-t files in current folder (no use of tobac-folder)" & NL
  i += 1: Thelp(i) = "-v version: show version info and end" & NL & NL
  i += 1: Thelp(i) = "To use aditional functions => start with GUI." & NL & NL

  AZThelp = i
  Tmsg(00) = "#ERROR " + PROG_NAME + ": insert code!"
  Tmsg(01) = "Welcome"
  Tmsg(02) = " to "
  Tmsg(03) = ": no XML file"
  Tmsg(04) = "!" & NL
  Tmsg(05) = "Sketching?"
  Tmsg(06) = "_Yes"
  Tmsg(07) = "_No"
  Tmsg(08) = "_Cancel"
  Tmsg(09) = " >> Yes"
  Tmsg(10) = " >> No"
  Tmsg(11) = " >> Cancel"
  Tmsg(12) = "Clean up"
  Tmsg(13) = "Done!"
  Tmsg(14) = "Choose GUI-XML-file!" & NL
  Tmsg(15) = "Readerror: "
  Tmsg(16) = "    existing"
  Tmsg(17) = "to be writen"
  Tmsg(18) = " >> ERROR!" & NL
  Tmsg(19) = " >> deleted!" & NL
  Tmsg(20) = " delete?"
  Tmsg(21) = "Load GUI-XML-file first!"
  Tmsg(22) = " - marking:" & NL
  Tmsg(23) = "Done: there are "
  Tmsg(24) = " files unneeded!"
  Tmsg(25) = "To do?"
  Tmsg(26) = "Delete _All"
  Tmsg(27) = "Delete _Single"
  Tmsg(28) = "_No deleting"
  Tmsg(29) = " >> delete all" & NL
  Tmsg(30) = " >> delete single" & NL
  Tmsg(31) = " >> No deleting" & NL
  Tmsg(32) = "File "
  Tmsg(33) = " >> Write error!"
  Tmsg(34) = " >> written!"
  Tmsg(35) = "Load GUI-XML-file:"
  Tmsg(36) = ""
  Tmsg(37) = "" '"XML files (*.xml)"
  Tmsg(38) = "Loading "
  Tmsg(39) = " >> loaded!" & NL & NL+"RESULTS:" & NL
  Tmsg(40) = "nam. Widgets: "
  Tmsg(41) = "Callbacks   : "
  Tmsg(42) = "    existing: "
  Tmsg(43) = "         new: "
  Tmsg(44) = "    unneeded: "
  Tmsg(45) = " (staying unchanged)"
  Tmsg(46) = " (to be written)"
  Tmsg(47) = " (may be cleaned up)"
  Tmsg(48) = "Callbacks"
  Tmsg(49) = "Widgets"
  Tmsg(50) = ">> Error! to much "
  Tmsg(51) = "Sketching" & NL
  Tmsg(52) = "About: FreeBasic Code Sketcher"
  Tmsg(53) = !"Authors:\ninformation@siebke.com\nThomas.Freiherr@gmx.net\ngaleon@ymail.com"
  Tmsg(54) = "Supports RAD (Rapid Application Development)" & NL+"for GTK-GUI (Grafic User Interface)" & NL+"with programs Glade3 and FreeBasic. "
  Tmsg(55) = "Lizense: GPLv3 (see http://gplv3.fsf.org/)."
  Tmsg(56) = "Can't open file: "
  Tmsg(57) = "Userdefined"
  Tmsg(58) = "Folder "
  Tmsg(59) = "Done: there is "
  Tmsg(60) = " file unneeded:"
  Tmsg(61) = " definitions found!"
' text for GUI / GUI-Texte

  i=0
  i += 1: LaCha(i) = TYPE(GUI_MenuItem, mnu_datei,    @"_File")
  i += 1: LaCha(i) = TYPE(GUI_MenuItem, mnu_hilfe,    @"_Help")
  i += 1: LaCha(i) = TYPE(GUI_MenuItem, MnuDatei,     @"_Load and analyse")
  i += 1: LaCha(i) = TYPE(GUI_MenuItem, MnuGenerate,  @"Code _sketching")
  i += 1: LaCha(i) = TYPE(GUI_MenuItem, MnuAusmisten, @"_Clear up")
  i += 1: LaCha(i) = TYPE(GUI_MenuItem, MnuExit,      @"_Exit")
  i += 1: LaCha(i) = TYPE(GUI_MenuItem, MnuLang,      @"_Deutsch")

  i += 1: LaCha(i) = TYPE(GUI_ToolTip, EntName,      @"Insert your Name")
  i += 1: LaCha(i) = TYPE(GUI_ToolTip, EntEmail,     @"Insert Email adress (e.g. 'email://My.Name@home.net' - !spam?)")
  i += 1: LaCha(i) = TYPE(GUI_ToolTip, EntWeb,       @"Insert URL for your website (e.g. 'http://www.meins.net')")
  i += 1: LaCha(i) = TYPE(GUI_ToolTip, EntSyn,       @"Short description of Project. A long version can be imported from the file *.desc, if exists.")
  i += 1: LaCha(i) = TYPE(GUI_ToolTip, EntVer,       @"Start version of project. Later, the version will be red from *.bas, if exists.")
  i += 1: LaCha(i) = TYPE(GUI_ToolTip, EntTyNa,      @"Name of TYPE-definition, used for variables of UI. When empty, the UI-variables are global.")
  i += 1: LaCha(i) = TYPE(GUI_ToolTip, CheOld,       @"When aktiv: GTK-versions >= 2.12 can be used (with reduced functionality). Otherwise GTK-version >= 2.18.6 is expected/will be checked.")
  i += 1: LaCha(i) = TYPE(GUI_ToolTip, ComLiz,       @"Choose your license here (used in main program and in readme.txt)")
  i += 1: LaCha(i) = TYPE(GUI_ToolTip, CheGlaIn,     @"When activ: generate *_glad.bas and including in source code")
  i += 1: LaCha(i) = TYPE(GUI_ToolTip, CheTobac,     @"When activ: generate callbacks *.bas in folder tobac, also *_tobac.bas and *_glad.bas)")
  i += 1: LaCha(i) = TYPE(GUI_ToolTip, CheMake,      @"When activ: generate 'makefile' in main folder, if not exists")
  i += 1: LaCha(i) = TYPE(GUI_ToolTip, CheReadMe,    @"When activ: generate 'readme.txt' in main folder, if not exists")
  i += 1: LaCha(i) = TYPE(GUI_ToolTip, CheGeany,     @"When activ: generate Geany project file '*.geany' in main folder, if not exists")
  i += 1: LaCha(i) = TYPE(GUI_ToolTip, CheFbIde,     @"When activ: generate FB-IDE project file '*.fbide.fbp' in main folder, if not exists")
  i += 1: LaCha(i) = TYPE(GUI_ToolTip, CheFbEdit,    @"When activ: generate FB-Edit-Projekt-Datei '*.fbp' in main folder, if not exists")
  i += 1: LaCha(i) = TYPE(GUI_ToolTip, CheJelly,     @"When activ: generate Jelly-Projekt-Datei '*.jfp' in main folder, if not exists")
  i += 1: LaCha(i) = TYPE(GUI_ToolTip, CheWin,       @"When activ: generate Windows-Resource-Datei '*.rc' in main folder, if not exists")
  i += 1: LaCha(i) = TYPE(GUI_ToolTip, CheRc,        @"When activ: bind Icon file '*.ico' in Windows Resource file (*.rc)")
  i += 1: LaCha(i) = TYPE(GUI_ToolTip, ButDatei,     @"choose, load and analyse GUI file (*.ui/*.glade) for process")
  i += 1: LaCha(i) = TYPE(GUI_ToolTip, ButGenerate,  @"write files: *_tobac.bas (everytime) and callbacks *.bas (if not exists) and required files depending on choosen parameters")
  i += 1: LaCha(i) = TYPE(GUI_ToolTip, ButAusmisten, @"delete old and unneeded callbacks *.bas")
  i += 1: LaCha(i) = TYPE(GUI_ToolTip, ButExit,      @"end application and exit")

  i += 1: LaCha(i) = TYPE(GUI_Button, CheGlaIn,  @"GUI _in source")
  i += 1: LaCha(i) = TYPE(GUI_Button, CheTobac,  @"_tobac folder")
  i += 1: LaCha(i) = TYPE(GUI_Button, CheMake,   @"_makefile")
  i += 1: LaCha(i) = TYPE(GUI_Button, CheReadMe, @"_readme.txt")
  i += 1: LaCha(i) = TYPE(GUI_Button, CheGeany,  @"_Geany (*._geany)")
  i += 1: LaCha(i) = TYPE(GUI_Button, CheFbIde,  @"FB-I_DE (*.fbide.fbp)")
  i += 1: LaCha(i) = TYPE(GUI_Button, CheFbEdit, @"FB-_Edit (*.fbp)")
  i += 1: LaCha(i) = TYPE(GUI_Button, CheJelly,  @"_Jelly (*.jfp)")
  i += 1: LaCha(i) = TYPE(GUI_Button, CheWin,    @"Reso_urce (*.rc)")
  i += 1: LaCha(i) = TYPE(GUI_Button, CheRc,     @"Icon in *.r_c")
  i += 1: LaCha(i) = TYPE(GUI_Button, CheOld,    @"GT_K old versions")

  i += 1: LaCha(i) = TYPE(GUI_LabFrame, LabNeuPro,@"<b>New project</b>")
  i += 1: LaCha(i) = TYPE(GUI_LabFrame, LabTex,   @"<b>FreeBasic files</b>")
  i += 1: LaCha(i) = TYPE(GUI_LabFrame, LabProj,  @"<b>Project files</b>")

  i += 1: LaCha(i) = TYPE(GUI_Label, LabNam,   @"_Author:")
  i += 1: LaCha(i) = TYPE(GUI_Label, LabEmail, @"Emai_l:")
  i += 1: LaCha(i) = TYPE(GUI_Label, LabWeb,   @"_Website:")
  i += 1: LaCha(i) = TYPE(GUI_Label, LabSyn,   @"_Synopsis:")
  i += 1: LaCha(i) = TYPE(GUI_Label, LabVer,   @"_Version:")
  i += 1: LaCha(i) = TYPE(GUI_Label, LabNot0,  @"_Parameters")
  i += 1: LaCha(i) = TYPE(GUI_Label, LabNot1,  @"_Output")

  i += 1: LaCha(i) = TYPE(GUI_ToolButton, ButDatei,     @"Load GUI file")
  i += 1: LaCha(i) = TYPE(GUI_ToolButton, ButGenerate,  @"Code sketching")
  i += 1: LaCha(i) = TYPE(GUI_ToolButton, ButAusmisten, @"Clean up")
  i += 1: LaCha(i) = TYPE(GUI_ToolButton, ButExit,      @"Exit program")
  LaCha(0).Typ = i
END SUB

'*
'*  Defining message text for standard language germen
'*  Definiert die Texte fuer deutsche Kommunikation (Standard)
'***********************************************************************
SUB set_lger()
  DIM AS INTEGER i = 0
  i += 1: Thelp(i) = "Kurzhilfe (Details in '" + PROG_NAME + "_LiesMich.txt')" & NL & NL
  i += 1: Thelp(i) = "Aufruf: " + PROG_NAME + " >PFAD" + SLASH + "DATEI<.[ui|glade] -Schalter" & NL & NL
  i += 1: Thelp(i) = PROG_NAME + " führt folgende Schritte aus" & NL
  i += 1: Thelp(i) = "1.) GUI-XML-Datei laden und analysieren" & NL
  i += 1: Thelp(i) = "2.) Quelltext-Dateien schreiben (wird durch -n oder -N abgeschaltet)" & NL
  i += 1: Thelp(i) = "3.) veraltete Dateien löschen (wird durch -a oder -A angeschaltet)" & NL & NL
  i += 1: Thelp(i) = "Wenn keine gültige Datei angegeben ist, startet die grafische Oberfläche." & NL & NL
  i += 1: Thelp(i) = "Schalter (einzeln setzen, durch Leerzeichen getrennt):" & NL
  i += 1: Thelp(i) = "-h Hilfe (Ausgabe dieses Textes und Programmende)" & NL
  i += 1: Thelp(i) = "-a Funktion Ausmisten ausführen, Bestätigung vor dem Löschen" & NL
  i += 1: Thelp(i) = "-A Funktion Ausmisten ausführen, ohne Bestätigung beim Löschen" & NL
  i += 1: Thelp(i) = "-i Integrieren der GUI-XML-Datei in den Quelltext (für finale Version)" & NL
  i += 1: Thelp(i) = "-l Language: Auswahl der Sprache (derzeit 'en' od. 'de'{=Vorgabe}))" & NL
  i += 1: Thelp(i) = "-n NoAction: Datei analysieren, Quelltext generieren auf Tastendruck" & NL
  i += 1: Thelp(i) = "-N NoAction: Datei analysieren, keinen Quelltext generieren" & NL
  i += 1: Thelp(i) = "-t Callback-Dateien im aktuellen Ordner (kein tobac-Ordner)" & NL
  i += 1: Thelp(i) = "-v Ausgabe der Version und Programmende" & NL & NL
  i += 1: Thelp(i) = "Weitere Funktionen nutzen => Start mit grafischer Oberfläche." & NL & NL

  AZThelp = i
  Tmsg(00) = "  #ERROR " + PROG_NAME + ": hier Quelltext einfuegen!"
  Tmsg(01) = "Willkommen"
  Tmsg(02) = " bei "
  Tmsg(03) = ": keine XML Datei geladen"
  Tmsg(04) = "!" & NL
  Tmsg(05) = "Bearbeiten?"
  Tmsg(06) = "_Ja"
  Tmsg(07) = "_Nein"
  Tmsg(08) = "_Abbruch"
  Tmsg(09) = " >> Ja"
  Tmsg(10) = " >> Nein"
  Tmsg(11) = " >> Abbruch"
  Tmsg(12) = "Ausmisten"
  Tmsg(13) = "Fertig!"
  Tmsg(14) = "GUI-XML-Datei auswählen!" & NL
  Tmsg(15) = "Lesefehler: "
  Tmsg(16) = "   vorhanden"
  Tmsg(17) = "wird erzeugt"
  Tmsg(18) = " >> Fehler!" & NL
  Tmsg(19) = " >> gelöscht!" & NL
  Tmsg(20) = " löschen?"
  Tmsg(21) = "Erst GUI-XML-Datei laden!"
  Tmsg(22) = " - markiere:" & NL
  Tmsg(23) = "Fertig: es sind "
  Tmsg(24) = " Dateien veraltet!"
  Tmsg(25) = "Aktion?"
  Tmsg(26) = "_Alle löschen"
  Tmsg(27) = "_Einzeln löschen"
  Tmsg(28) = "_Nicht löschen"
  Tmsg(29) = " >> Alle löschen" & NL
  Tmsg(30) = " >> Einzeln löschen" & NL
  Tmsg(31) = " >> Nicht löschen" & NL
  Tmsg(32) = "Datei "
  Tmsg(33) = " >> Schreibfehler!"
  Tmsg(34) = " >> geschrieben!"
  Tmsg(35) = "GUI-XML-Datei laden:"
  Tmsg(36) = ""
  Tmsg(37) = "" '"XML Dateien (*.xml)"
  Tmsg(38) = "Lade "
  Tmsg(39) = " >> geladen!" & NL & NL &"AUSWERTUNG:" & NL
  Tmsg(40) = "ben. Widgets: "
  Tmsg(41) = "Callbacks   : "
  Tmsg(42) = "   vorhanden: "
  Tmsg(43) = "         neu: "
  Tmsg(44) = "    veraltet: "
  Tmsg(45) = " (bleiben bestehen)"
  Tmsg(46) = " (werden erzeugt)"
  Tmsg(47) = " (ggf. ausmisten)"
  Tmsg(48) = "Callbacks"
  Tmsg(49) = "Widgets"
  Tmsg(50) = ">> Fehler! Zu viele "
  Tmsg(51) = "Bearbeite" & NL
  Tmsg(52) = "Über: FreeBasic Code Sketcher"
  Tmsg(53) = !"Autoren:\ninformation@siebke.com\nThomas.Freiherr@gmx.net\ngaleon@ymail.com"
  Tmsg(54) = "Unterstützt die rasche GTK-GUI (grafic user interface) Entwicklung mit den Programmen Glade3 und FreeBasic. "
  Tmsg(55) = "Lizenz: GPLv3 (siehe http://gplv3.fsf.org/)."
  Tmsg(56) = "Kann Datei nicht öffnen: "
  Tmsg(57) = "Benutzerdefiniert"
  Tmsg(58) = "Ordner "
  Tmsg(59) = "Fertig: es ist "
  Tmsg(60) = " Datei veraltet:"
  Tmsg(61) = " Definitionen gefunden!"

' text for GUI / GUI-Texte
  i=0
  i += 1: LaCha(i) = TYPE(GUI_MenuItem, mnu_datei,    @"_Datei")
  i += 1: LaCha(i) = TYPE(GUI_MenuItem, mnu_hilfe,    @"_Hilfe")
  i += 1: LaCha(i) = TYPE(GUI_MenuItem, MnuDatei,     @"_Laden und analysieren")
  i += 1: LaCha(i) = TYPE(GUI_MenuItem, MnuGenerate,  @"_Bearbeiten")
  i += 1: LaCha(i) = TYPE(GUI_MenuItem, MnuAusmisten, @"_Ausmisten")
  i += 1: LaCha(i) = TYPE(GUI_MenuItem, MnuExit,      @"B_eenden")
  i += 1: LaCha(i) = TYPE(GUI_MenuItem, MnuLang,      @"_English")

  i += 1: LaCha(i) = TYPE(GUI_ToolTip, EntName,      @"Namen des Programmierers hier eingeben. Wird in die Textdateien übernommen")
  i += 1: LaCha(i) = TYPE(GUI_ToolTip, EntEmail,     @"Wenn gewünscht: eine Emailadresse angeben (z.B. 'email://Vornahme.Nachnahme@home.net' - !Spam?)")
  i += 1: LaCha(i) = TYPE(GUI_ToolTip, EntWeb,       @"Eine URL eingeben (z.B. 'http://www.meins.net').")
  i += 1: LaCha(i) = TYPE(GUI_ToolTip, EntSyn,       @"Kurzbeschreibung des Projektes. Eine ausführliche Beschreibung wird aus der Datei *.desc importiert, falls diese existiert.")
  i += 1: LaCha(i) = TYPE(GUI_ToolTip, EntVer,       @"Startversion des Projektes. Später wird die Version aus der Datei *.bas gelesen, falls diese vorhanden ist.")
  i += 1: LaCha(i) = TYPE(GUI_ToolTip, EntTyNa,      @"Name der TYPE-Definition, in der die Variablen für das UI zusammengefaßt werden. Wenn leer, dann sind UI-Variablen global.")
  i += 1: LaCha(i) = TYPE(GUI_ToolTip, CheOld,       @"Wenn aktiv: GTK-Versionen ab 2.12 können genutzt werden (eingeschränkter Funktionsumfang). Sonst wird GTK-Version >= 2.18.6 erwartet/abgefragt.")
  i += 1: LaCha(i) = TYPE(GUI_ToolTip, ComLiz,       @"Gewünschte Lizenz auswählen (wird im Hauptprogramm und ggf. im readme.txt eingefügt)")
  i += 1: LaCha(i) = TYPE(GUI_ToolTip, CheGlaIn,     @"Wenn aktiv: Datei *_glad.bas wird erzeugt und in den Quelltext integriert")
  i += 1: LaCha(i) = TYPE(GUI_ToolTip, CheTobac,     @"Wenn aktiv: Callback-Dateien *.bas werden im Ordner tobac verwaltet (auch *_tobac.bas und *_glad.bas)")
  i += 1: LaCha(i) = TYPE(GUI_ToolTip, CheMake,      @"Wenn aktiv: eine Datei 'makefile' wird im Hauptordner erzeugt, falls noch nicht vorhanden")
  i += 1: LaCha(i) = TYPE(GUI_ToolTip, CheReadMe,    @"Wenn aktiv: eine Datei 'readme.txt' wird im Hauptordner erzeugt, falls noch nicht vorhanden")
  i += 1: LaCha(i) = TYPE(GUI_ToolTip, CheGeany,     @"Wenn aktiv: eine Geany-Projekt-Datei '*.geany' wird im Hauptordner erzeugt, falls noch nicht vorhanden")
  i += 1: LaCha(i) = TYPE(GUI_ToolTip, CheFbIde,     @"Wenn aktiv: eine FB-IDE-Projekt-Datei '*.fbide.fbp' wird im Hauptordner erzeugt, falls noch nicht vorhanden")
  i += 1: LaCha(i) = TYPE(GUI_ToolTip, CheFbEdit,    @"Wenn aktiv: eine FB-Edit-Projekt-Datei '*.fbp' wird im Hauptordner erzeugt, falls noch nicht vorhanden")
  i += 1: LaCha(i) = TYPE(GUI_ToolTip, CheJelly,     @"Wenn aktiv: eine Jelly-Projekt-Datei '*.jfp' wird im Hauptordner erzeugt, falls noch nicht vorhanden")
  i += 1: LaCha(i) = TYPE(GUI_ToolTip, CheWin,       @"Wenn aktiv: eine Windows-Resource-Datei '*.rc' wird im Hauptordner erzeugt, falls noch nicht vorhanden")
  i += 1: LaCha(i) = TYPE(GUI_ToolTip, CheRc,        @"Wenn aktiv: eine Icon Datei '*.ico' wird in die Windows-Resource-Datei (*.rc) eingebunden")
  i += 1: LaCha(i) = TYPE(GUI_ToolTip, ButDatei,     @"GUI-XML-Datei (*.ui/*.glade) auswählen, laden und analysieren")
  i += 1: LaCha(i) = TYPE(GUI_ToolTip, ButGenerate,  @"Dateien erzeugen: *_tobac.bas (immer) und ggf. Callbacks *.bas (falls nicht vorhanden), sowie weitere Dateien wie unter Einstellungen vorgesehen")
  i += 1: LaCha(i) = TYPE(GUI_ToolTip, ButAusmisten, @"Veraltete Callbacks *.bas löschen")
  i += 1: LaCha(i) = TYPE(GUI_ToolTip, ButExit,      @"Programm beenden, ini-Datei schreiben")

  i += 1: LaCha(i) = TYPE(GUI_Button, CheGlaIn,  @"GUI _in Quelltext")
  i += 1: LaCha(i) = TYPE(GUI_Button, CheTobac,  @"_tobac Ordner")
  i += 1: LaCha(i) = TYPE(GUI_Button, CheMake,   @"_makefile")
  i += 1: LaCha(i) = TYPE(GUI_Button, CheReadMe, @"_readme.txt")
  i += 1: LaCha(i) = TYPE(GUI_Button, CheGeany,  @"_Geany (*._geany)")
  i += 1: LaCha(i) = TYPE(GUI_Button, CheFbIde,  @"FB-I_DE (*.fbide.fbp)")
  i += 1: LaCha(i) = TYPE(GUI_Button, CheFbEdit, @"_FB-Edit (*.fbp)")
  i += 1: LaCha(i) = TYPE(GUI_Button, CheJelly,  @"_Jelly (*.jfp)")
  i += 1: LaCha(i) = TYPE(GUI_Button, CheWin,    @"Reso_urce (*.rc)")
  i += 1: LaCha(i) = TYPE(GUI_Button, CheRc,     @"Icon in *.r_c")
  i += 1: LaCha(i) = TYPE(GUI_Button, CheOld,    @"GTK alte Ver_sionen")

  i += 1: LaCha(i) = TYPE(GUI_LabFrame, LabNeuPro,@"<b>Neues Projekt</b>")
  i += 1: LaCha(i) = TYPE(GUI_LabFrame, LabTex,   @"<b>FreeBasic-Dateien</b>")
  i += 1: LaCha(i) = TYPE(GUI_LabFrame, LabProj,  @"<b>Projekt-Dateien</b>")

  i += 1: LaCha(i) = TYPE(GUI_Label, LabNam,   @"Aut_or:")
  i += 1: LaCha(i) = TYPE(GUI_Label, LabEmail, @"Emai_l:")
  i += 1: LaCha(i) = TYPE(GUI_Label, LabWeb,   @"_Website:")
  i += 1: LaCha(i) = TYPE(GUI_Label, LabSyn,   @"_Kurzbeschr.:")
  i += 1: LaCha(i) = TYPE(GUI_Label, LabVer,   @"_Version:")
  i += 1: LaCha(i) = TYPE(GUI_Label, LabNot0,  @"_Einstellungen")
  i += 1: LaCha(i) = TYPE(GUI_Label, LabNot1,  @"_Ausgabe")

  i += 1: LaCha(i) = TYPE(GUI_ToolButton, ButDatei,     @"GUI-XML-Datei")
  i += 1: LaCha(i) = TYPE(GUI_ToolButton, ButGenerate,  @"Bearbeiten")
  i += 1: LaCha(i) = TYPE(GUI_ToolButton, ButAusmisten, @"Ausmisten")
  i += 1: LaCha(i) = TYPE(GUI_ToolButton, ButExit,      @"Beenden")
  LaCha(0).Typ = i
END SUB

'*
'*  writing textes in GUI-Widgets (internationalisation)
'*  Schreibt Texte in die GUI-Widgets (Sprachanpassung)
'***********************************************************************
SUB set_GUI_lang()
  DIM AS GtkWidget PTR p
  FOR i AS INTEGER = 1 TO LaCha(0).Typ
    WITH LaCha(i)
      SELECT CASE .Typ
      CASE GUI_MenuItem
        p = gtk_container_get_children(GTK_CONTAINER(.Obj))->data
        gtk_label_set_text_with_mnemonic(GTK_LABEL(p), .Tex)
      CASE GUI_Label
        gtk_label_set_text_with_mnemonic(GTK_LABEL(.Obj), .Tex)
      CASE GUI_LabFrame
        gtk_label_set_markup(GTK_LABEL(.Obj), .Tex)
      CASE GUI_Button
        gtk_button_set_label(GTK_BUTTON(.Obj), .Tex)
      CASE GUI_ToolButton
        gtk_tool_button_set_label(GTK_TOOL_BUTTON(.Obj), .Tex)
      CASE GUI_ToolTip
        g_object_set(G_OBJECT(.Obj), "tooltip_text", .Tex, NULL)
      END SELECT
    END WITH
  NEXT i
  gtk_window_set_title(GTK_WINDOW(win_main), _
                       PROG_NAME & "(" & PROG_VERS & ")" & Tmsg(3))
  rausclr(Tmsg(1)) : raus(Tmsg(2))
  rausblau(PROG_NAME & "(" & PROG_VERS & ")") : raus(Tmsg(4))
END SUB
