'*
'*  Reading value after >wort< from line >zeile<
'*  Liest den Wert nach Schluessel>wort< aus >zeile< (XML Art mit >"<)
'***********************************************************************
FUNCTION find_value(BYREF zeile AS STRING, BYVAL wort AS STRING) AS STRING
  DIM AS INTEGER a = INSTR(zeile, wort)
  IF a = 0 THEN RETURN "" ' >wort< not detected / kein Schluesselwort
  a += LEN(wort): RETURN MID(zeile, a, INSTR(a, zeile, """") - a)
END FUNCTION
FUNCTION findWert(BYREF zeile AS STRING, BYVAL wort AS STRING) AS STRING
  DIM AS INTEGER e, a = INSTR(zeile, wort)
  IF a = 0 THEN RETURN "" ' >wort< not detected / kein Schluesselwort
  a += LEN(wort) : e = INSTR(a, zeile, NL)
  IF e = 0 THEN RETURN MID(zeile, a)
  RETURN MID(zeile, a, e - a)
END FUNCTION

'*
'*  if needed: converting UTF-8 for DOS output (for console window)
'*  Wenn nötig: UTF-8 in DOS-ANSI konvertieren (fuer DOS-Konsole)
'***********************************************************************
SUB PathCheck(BYREF p AS STRING)
  IF SLASH = "/" THEN EXIT SUB
  IF MID(p, 1, 1) = "/" THEN MID(p, 1, 1) = SLASH
END SUB

'*
'*  checking, if exists unneeded moduls in folder, deleting if required
'*  Prüft, ob veraltete Module im Ordner vorhanden, loescht ggf.
'***********************************************************************
FUNCTION callback_clear(BYVAL Modus AS INTEGER) AS INTEGER
  DIM AS INTEGER i, z = 0
  DIM AS STRING  n, t, p = _INI_.Path + slash
  IF _INI_.Toba THEN p += OrdTobac + slash
  n = DIR(p + "*" + SufBas)
  DO
    IF LEFT(n, LEN(_OUT_.PNam)) = _OUT_.PNam THEN
      IF RIGHT(n,LEN(SufGui)) <> SufGui THEN n="" ELSE IF _INI_.UiIn THEN n = ""
    ELSE
      FOR i = 0 TO AzCB - 1
        IF LEFT(n, LEN(n) - 4) = MID(NaCB(i), 5) THEN n = "" : EXIT FOR
      NEXT i
    END IF
    IF LEN(n) THEN
      z += 1
      SELECT CASE AS CONST Modus
        CASE 3 '  kill without confirmation / Loeschen ohne Bestaetigung
          rausrot(n)
          IF KILL(p+n) THEN rausrot(Tmsg(18)) ELSE raus(Tmsg(19))
        CASE 2 '      kill with confirmation / Loeschen mit Bestaetigung
          rausrot(n)
          SELECT CASE Antwort(Tmsg(20), Tmsg(6), Tmsg(7), Tmsg(8))
          CASE 1
            raus(Tmsg(9))
            IF KILL(p+n) THEN rausrot(Tmsg(18)) ELSE raus(Tmsg(19))
          CASE 2 : raus(Tmsg(10)+NL)
          CASE ELSE : raus(Tmsg(11)+NL) : EXIT DO
          END SELECT
        CASE 1 '           show files to be killed / Dateinamen anzeigen
          rausblau(n + NL)
        CASE ELSE '   just count, no output / nur zaehlen, keine Ausgabe
      END SELECT
    END IF
    n = DIR()
  LOOP WHILE LEN(n) : RETURN z
END FUNCTION

'*
'*  cleaning up of callback modules
'*  Ausmisten veralteter callbacks
'***********************************************************************
SUB ausmisten()
  rausclr(Tmsg(12)) ' function message / Funktion ankuendigen
  IF _OUT_.PNam = "" THEN rausrot(NL + Tmsg(21)) : EXIT SUB
  raus(Tmsg(22)) ' count unneeded callbacks / veraltete zaehlen
  DIM AS STRING t
  DIM AS INTEGER z = callback_clear(1)
  SELECT CASE AS CONST z
    CASE 0' nothing to do / nichts zu tun
      raus(Tmsg(23) + "0" + Tmsg(24))
    CASE 1' delete one single file / eine einzige Datei loeschen
      raus(Tmsg(59)):rausrot(STR(z)):raus(Tmsg(60) + NL)
      z = callback_clear(2)
    CASE ELSE
      raus(Tmsg(23)):rausrot(STR(z)):raus(Tmsg(24))
      SELECT CASE Antwort(Tmsg(25), Tmsg(26), Tmsg(27), Tmsg(28))
' delete without conformation / loeschen ohne Bestaetigung
        CASE 1 : raus(Tmsg(29)) : z = callback_clear(3)
' delete with conformation / loeschen mit Bestaetigung
        CASE 2 : raus(Tmsg(30)) : z = callback_clear(2)
        CASE ELSE : raus(Tmsg(31)) ' Cancel / Abbruch
      END SELECT
  END SELECT
END SUB

'*
'*  writing code to file >n< in folder >p<
'*  Schreiben der code Zeilen in Datei >n< im Pfad >p<
'***********************************************************************
SUB write_code(BYVAL p AS STRING, BYVAL n AS STRING)
  DIM AS INTEGER f = FREEFILE
  raus(Tmsg(32)) : rausblau(n) ': raus(" ...")
  IF OPEN (p + n FOR OUTPUT AS #f) THEN
    rausrot(Tmsg(33)+NL) ' writeerror / Schreibfehler
  ELSE
    PRINT #f, ausg;
    CLOSE #f
    raus(Tmsg(34)+NL)' OK
  END IF
END SUB

'*
'*  reads version from *.bas file
'*  liest die Version aus der *.bas-Datei
'***********************************************************************
FUNCTION readProgPara() AS INTEGER
  DIM AS STRING z, r, n = _INI_.Path & SLASH & _OUT_.PNam & SufBas
  IF NOT FILEEXISTS(n) THEN RETURN FALSE
  DIM AS INTEGER e, l, fnr = FREEFILE
  IF OPEN(n FOR INPUT AS #fnr) THEN RETURN FALSE
  n = RTRIM(tobac_C_end, NL)
  WHILE NOT EOF(fnr)
    LINE INPUT #fnr, z
    IF z = n THEN EXIT WHILE
    r += z & NL
  WEND
  WITH _OUT_
    .Auth = find_value(r, BasAuth)
    .Mail = find_value(r, BasMail)
    .Site = find_value(r, BasSite)
    .Desc = find_value(r, BasDesc)
    .Vers = find_value(r, BasVers)
    .Jahr = find_value(r, BasYear)
    .Old = -(INSTR(r, BasOld) <> 0)
    l = LEN(BasUnre)
    WHILE NOT EOF(fnr)
      LINE INPUT #fnr, z
      IF LEFT(z, l) = BasUnre THEN
        e = INSTR(l, z, ")") - 1
        n = MID(z, l + 1, e - l)
        e = INSTR(n, ".")
        IF e THEN .TyNa = LEFT(n, e - 1) ELSE .TyNa = ""
        EXIT WHILE
      END IF
    WEND : CLOSE #fnr
    .Bas = TRUE
  END WITH : RETURN TRUE
END FUNCTION

'*
'*  reads buttons from UI
'*  liest die Schalter aus der Benutzeroberflaeche
'***********************************************************************
SUB GUIgetButt()
  IF NoGUI THEN EXIT SUB
  WITH _INI_
  .UiIn = gtk_toggle_button_get_active(GTK_TOGGLE_BUTTON(CheGlaIn))
  .Toba = gtk_toggle_button_get_active(GTK_TOGGLE_BUTTON(CheTobac))

  .Make   = gtk_toggle_button_get_active(GTK_TOGGLE_BUTTON(CheMake))
  .ReadMe = gtk_toggle_button_get_active(GTK_TOGGLE_BUTTON(CheReadMe))
  .Geany  = gtk_toggle_button_get_active(GTK_TOGGLE_BUTTON(CheGeany))
  .FbIde  = gtk_toggle_button_get_active(GTK_TOGGLE_BUTTON(CheFbIde))
  .FbEdit = gtk_toggle_button_get_active(GTK_TOGGLE_BUTTON(CheFbEdit))
  .Jelly  = gtk_toggle_button_get_active(GTK_TOGGLE_BUTTON(CheJelly))
  .Win    = gtk_toggle_button_get_active(GTK_TOGGLE_BUTTON(CheWin))
  .Rc     = gtk_toggle_button_get_active(GTK_TOGGLE_BUTTON(CheRc))
  .Liz = gtk_combo_box_get_active(GTK_COMBO_BOX(ComLiz))
  END WITH
END SUB

'*
'*  reads parameters from UI
'*  liest die Parameter aus der Benutzeroberflaeche
'***********************************************************************
SUB GUIgetPara()
  IF NoGUI THEN EXIT SUB
  WITH _INI_
    .Auth = *gtk_entry_get_text(GTK_ENTRY(EntName))
    .Mail = *gtk_entry_get_text(GTK_ENTRY(EntEmail))
    .Site = *gtk_entry_get_text(GTK_ENTRY(EntWeb))
    .Desc = *gtk_entry_get_text(GTK_ENTRY(EntSyn))
    .Vers = *gtk_entry_get_text(GTK_ENTRY(EntVer))
    .TyNa = *gtk_entry_get_text(GTK_ENTRY(EntTyNa))
    .Old  = gtk_toggle_button_get_active(GTK_TOGGLE_BUTTON(CheOld))
    GUIgetButt()
  END WITH
END SUB

'*
'*  writes parameters from UI into ini-file
'*  schreibt die Parameter aus dem GUI in die ini-Datei
'***********************************************************************
SUB INIsavePara()
  DIM AS STRING a = MyDir & PROG_NAME & SufIni
  DIM AS INTEGER fnr = FREEFILE
  IF OPEN(a FOR OUTPUT AS #fnr) THEN
    rausrot(NL & "Kann ini-File nicht schreiben: " & a & NL)
  ELSE
    WITH _INI_
      PRINT #fnr,        "PathName=" & .Path
      PRINT #fnr,       "WindWidth=" & .Brei
      PRINT #fnr,      "WindHeight=" & .Hoch
      PRINT #fnr,      "AuthorName=" & .Auth
      PRINT #fnr,     "AuthorEmail=" & .Mail
      PRINT #fnr,   "AuthorWebsite=" & .Site
      PRINT #fnr, "ProgramSynopsis=" & .Desc
      PRINT #fnr,  "ProgramVersion=" & .Vers
      PRINT #fnr,        "TypeName=" & .TyNa
      PRINT #fnr,   "AlteVersionen=" & .Old
      PRINT #fnr,  "ProgramLicense=" & .Liz

      PRINT #fnr,  "Glade=" & .UiIn
      PRINT #fnr,  "Tobac=" & .Toba
      PRINT #fnr,   "Make=" & .Make
      PRINT #fnr, "ReadMe=" & .ReadMe
      PRINT #fnr,  "Geany=" & .Geany
      PRINT #fnr,  "FbIde=" & .FbIde
      PRINT #fnr, "FbEdit=" & .FbEdit
      PRINT #fnr,  "Jelly=" & .Jelly
      PRINT #fnr,    "Win=" & .Win
      PRINT #fnr,     "Rc=" & .Rc
    END WITH
    CLOSE #fnr
  END IF
END SUB

'*
'*  reades parameters from ini-file into GUI
'*  liest die Parameter aus dem ini-Datei und schreibt in GUI
'***********************************************************************
SUB INIloadPara()
  DIM AS STRING p, a = MyDir & PROG_NAME & SufIni
  DIM AS INTEGER fnr = FREEFILE
  WITH _INI_
    IF OPEN(a FOR INPUT AS #fnr) THEN ' keine .ini, Defaultwerte
      .Path = EXEPATH
      gtk_window_get_size(GTK_WINDOW(win_main), @.Brei, @.Hoch)

      .Auth = "<NO AUTHOR>"
      .Mail = "<NO EMAIL>"
      .Site = "<NO WEBSITE>"
      .Desc = "<NO SDESC>"
      .Vers = "0.0"
      .Liz = 0

      .UiIn = FALSE
      .Toba = TRUE
      .Make   = FALSE
      .ReadMe = FALSE
      .Geany  = FALSE
      .FbIde  = FALSE
      .FbEdit = FALSE
      .Jelly  = FALSE
      .Win    = FALSE
      .Rc     = FALSE
      INIsavePara()
    ELSE '                               file
      WHILE NOT EOF(fnr)
        LINE INPUT #fnr, a
        p += a & NL
      WEND : CLOSE #fnr
      .Path = findWert(p, "PathName=") : PathCheck(.Path)
      .Brei = VALINT(findWert(p, "WindWidth="))
      .Hoch = VALINT(findWert(p, "WindHeight="))
      .Auth = findWert(p, "AuthorName=")
      .Mail = findWert(p, "AuthorEmail=")
      .Site = findWert(p, "AuthorWebsite=")
      .Desc = findWert(p, "ProgramSynopsis=")
      .Vers = findWert(p, "ProgramVersion=")
      .TyNa = findWert(p, "TypeName=")
      .Old  = -(VALINT(findWert(p, "AlteVersionen=")) = 1)
      .Liz = VALINT(findWert(p, "ProgramLicense="))

      .UiIn = -(VALINT(findWert(p, "Glade=")) = 1)
      .Toba = -(VALINT(findWert(p, "Tobac=")) = 1)
      .Make   = -(VALINT(findWert(p, "Make=")) = 1)
      .ReadMe = -(VALINT(findWert(p, "ReadMe=")) = 1)
      .Geany  = -(VALINT(findWert(p, "Geany=")) = 1)
      .FbIde  = -(VALINT(findWert(p, "FbIde=")) = 1)
      .FbEdit = -(VALINT(findWert(p, "FbEdit=")) = 1)
      .Jelly  = -(VALINT(findWert(p, "Jelly=")) = 1)
      .Win    = -(VALINT(findWert(p, "Win=")) = 1)
      .Rc     = -(VALINT(findWert(p, "Rc=")) = 1)
    END IF
  END WITH
END SUB

'*
'*  loads license names into Combo and String field
'*  laedt Dateinamen in Sfringfeld und in Combobox
'***********************************************************************
SUB LIZloadNames(BYVAL p AS STRING)
  DIM AS INTEGER nr = UBOUND(Licenses), fnr = FREEFILE
  DIM AS STRING n = DIR(p & "*.lic")
  DIM AS GtkComboBox PTR cobo = GTK_COMBO_BOX(ComLiz)
  DIM AS GtkCellRenderer PTR cell
  cell = gtk_cell_renderer_text_new()
  gtk_cell_layout_pack_start(GTK_CELL_LAYOUT(ComLiz), cell, TRUE)
  gtk_cell_layout_set_attributes(GTK_CELL_LAYOUT(ComLiz), cell, "text", 0, NULL)
  WHILE LEN(n)
    Licenses(nr) = n
    IF OPEN (p & n FOR INPUT AS #1) THEN
      ?Tmsg(56) & p & n
    ELSE
      LINE INPUT #fnr, n
      CLOSE #fnr
      gtk_combo_box_append_text(cobo, n)
      nr += 1
      REDIM PRESERVE AS STRING Licenses(nr)
    END IF : n = DIR()
  WEND : gtk_combo_box_append_text(cobo, Tmsg(57))
  fnr = IIF(_INI_.Liz > nr, nr, _INI_.Liz)
  gtk_combo_box_set_active(cobo, IIF(fnr < 0, 0, fnr))
END SUB

'*
'*  checks id, if userdefined or Glade-automatic
'*  prueft ob Glade-ID (=n) handvergeben wurde
'***********************************************************************
FUNCTION UserName (BYVAL w AS STRING, BYVAL n AS STRING) AS INTEGER
  DIM AS INTEGER pw = LEN(w) - 1, pn = LEN(n) - 1
  WHILE pn >= 0 ' Zahl am Ende ueberlesen
    IF n[pn] > ASC("9") THEN EXIT WHILE
    IF n[pn] < ASC("0") THEN EXIT WHILE
    pn -= 1
  WEND
  WHILE pn >= 0 ' vergleichen
    IF (n[pn] - w[pw]) AND 31 THEN EXIT WHILE
    pn -= 1 : pw -= 1 : IF pw < 0 THEN EXIT WHILE
  WEND : IF pn < 0 THEN RETURN FALSE
  RETURN TRUE
END FUNCTION

'*
'*  showing red program parameters
'*  zeigt die eingelesenen Program Parameter
'***********************************************************************
SUB showBas()
  WITH _OUT_
    IF .Bas = FALSE THEN EXIT SUB
    IF LEN(.Jahr) THEN raus(BasYear) : rausblau(.Jahr) : raus("""" & NL)
    IF LEN(.Auth) THEN raus(BasAuth) : rausblau(.Auth) : raus("""" & NL)
    IF LEN(.Mail) THEN raus(BasMail) : rausblau(.Mail) : raus("""" & NL)
    IF LEN(.Site) THEN raus(BasSite) : rausblau(.Site) : raus("""" & NL)
    IF LEN(.Desc) THEN raus(BasDesc) : rausblau(.Desc) : raus("""" & NL)
    IF LEN(.Vers) THEN raus(BasVers) : rausblau(.Vers) : raus("""" & NL)
    IF LEN(.TyNa) THEN raus("TYPE Name ") : rausblau(.TyNa & NL)
    IF .Old THEN rausblau(BasOld & NL)
  END WITH
END SUB

'*
'*  Checking parameters from *.bas file, setting from GUI if not exists
'*  liest Einstellungen aus *.bas Datei, setzt aus GUI wenn keine *.bas Datei
'***********************************************************************
SUB checkPara()
  IF readProgPara() THEN GUIgetButt() : EXIT SUB
  GUIgetPara()
  WITH _OUT_
    .Jahr = STR(YEAR(NOW))
    .Auth = _INI_.Auth
    .Mail = _INI_.Mail
    .Site = _INI_.Site
    .Vers = _INI_.Vers
    .Desc = _INI_.Desc
    .TyNa = _INI_.TyNa
    .Old  = _INI_.Old
    .Bas = FALSE
  END WITH
END SUB

'*
'*  specifing, loading and analysing glade XML file
'*  Auswählen, Einlesen und Auswerten der glade XML-Datei
'***********************************************************************
SUB read_UIfile(BYVAL nam AS STRING)
  DIM AS INTEGER           fnr, a, e
  DIM AS STRING            p, n, widn, wids, zeile, cuwi
  DIM AS     GtkWidget PTR dialog
  DIM AS GtkFileFilter PTR filter
  DIM AS       ZSTRING PTR fnp

  IF LEN(nam) THEN
    e = INSTRREV(nam, ".")
    a = INSTRREV(nam, slash, e - 1) + 1
    _INI_.Path = LEFT(nam, a - 2)
    _OUT_.PNam = MID(nam, a, INSTRREV(nam, ".") - a)
    _OUT_.Suff = LCASE(MID(nam, e))
    _OUT_.PaNa = nam
  ELSE
    dialog = gtk_file_chooser_dialog_new(_
        Tmsg(35), NULL, GTK_FILE_CHOOSER_ACTION_OPEN,_
        GTK_STOCK_CANCEL, GTK_RESPONSE_CANCEL,_
        GTK_STOCK_OPEN, GTK_RESPONSE_ACCEPT, NULL )
    gtk_file_chooser_set_current_folder(GTK_FILE_CHOOSER(dialog), _INI_.Path)
    filter = gtk_file_filter_new()
    gtk_file_filter_set_name(filter, "GtkBuilder (*" & SufBui & ")")
    gtk_file_filter_add_pattern(filter, "*" & SufBui)
    gtk_file_chooser_add_filter(GTK_FILE_CHOOSER(dialog), filter)
    filter = gtk_file_filter_new()
    gtk_file_filter_set_name(filter, "Glade (*" & SufGla & ")")
    gtk_file_filter_add_pattern(filter, "*" & SufGla)
    gtk_file_chooser_add_filter(GTK_FILE_CHOOSER(dialog), filter)
    gtk_window_set_transient_for(GTK_WINDOW(dialog), GTK_WINDOW(win_main))
    IF gtk_dialog_run(GTK_DIALOG(dialog)) <> GTK_RESPONSE_ACCEPT THEN
      gtk_widget_destroy(dialog)
      _OUT_.PaNa = "" : EXIT SUB
    END IF
' Ergebnis auswerten
    fnp = gtk_file_chooser_get_filename(GTK_FILE_CHOOSER(dialog))
    _OUT_.PaNa = *fnp
    g_free(fnp)
    gtk_widget_destroy(dialog)
    IF LEN(_OUT_.PaNa) = 0 THEN EXIT SUB
    e = INSTRREV(_OUT_.PaNa, ".")
    a = INSTRREV(_OUT_.PaNa, slash, e - 1) + 1
    _INI_.Path = LEFT(_OUT_.PaNa, a - 2)
    _OUT_.PNam = MID(_OUT_.PaNa, a, e - a)
    _OUT_.Suff = LCASE(MID(_OUT_.PaNa, e))
  END IF

  n = _OUT_.PNam & _OUT_.Suff
  IF NOGUI = FALSE THEN
    n = filename_to_utf8(n)
    Tmsg(3) = PROG_NAME  & "(" & PROG_VERS & "): " + n
    gtk_window_set_title(GTK_WINDOW(win_main), Tmsg(3))
  END IF
  rausclr(Tmsg(38)): rausblau(n)
' reset counter / Zähler zurücksetzen
  AzCB = 0
  AzUN = 0
  a = 0
  IF _OUT_.Suff = SufGla THEN wids = "<widget" ELSE wids = "<object"
  wids += " class="""
' Collect the user defined signals in array "callbacks"
' Ermitteln der Benutzersignale und merken in Matrix "callbacks"
  fnr = FREEFILE
  IF OPEN (_OUT_.PaNa FOR INPUT AS #fnr) THEN
    rausrot(Tmsg(18)) ' Error / Fehler
    _OUT_.PNam = ""
    EXIT SUB
  END IF
  p = _INI_.Path + slash : IF _INI_.Toba THEN p += OrdTobac + slash
  WHILE NOT EOF(fnr)
    LINE INPUT #fnr, zeile
' Check for user defined signal / nach Signal suchen
    n = find_value(zeile, "handler=""")
    IF LEN(n) THEN
      IF LEFT(n, 4) <> "gtk_" THEN
        FOR i AS INTEGER = 0 TO AzCB - 1
          IF n = MID(NaCB(i), 5) THEN n = "" : EXIT FOR
        NEXT
        IF LEN(n) THEN
          NaCB(AzCB) = findSig(cuwi, find_value(zeile, "name=""")) & n
          IF NOT FILEEXISTS (p + n + SufBas) THEN a += 1
          AzCB += 1 : IF AzCB > UBOUND(NaCB) THEN a = -1 : EXIT WHILE ' Feldkapazitaet
        END IF
      END IF
    END IF
' Check if user defined name / nach haendischer Benennung suchen
    Widn = find_value(zeile, wids)
    IF LEN(Widn) THEN
      cuwi = Widn
      n = find_value(zeile, "id=""")
      IF INSTR(n, "-") = 0 THEN ' fuer FB keine Minuszeichen im Namen
        IF UserName(Widn, n) THEN UsNa(AzUN) = n : AzUN += 1
        IF AzUN = 0 THEN UsNa(AzUN) = n : AzUN += 1 ' erstes Widget immer
        IF AzUN > UBOUND(UsNa) THEN a = -2 : EXIT WHILE ' Feldkapazitaet erreicht
      END IF
    END IF
  WEND : CLOSE #fnr

' output results / Ausgabe der Ergebnisse
  IF a >= 0 THEN
    raus(Tmsg(39))
    checkPara()
' Auswertung Glade Datei Fenster/Callbacks
    raus(Tmsg(40) & AzUN & NL)
    raus(Tmsg(41) & AzCB & NL)
    rausblau(Tmsg(58)) : raus(p & NL)
    fnr = AzCB - a
    DataDa(Tmsg(42), fnr, Tmsg(45), "b")
    DataDa(Tmsg(43),   a, Tmsg(46), "r")
    fnr = callback_clear(0)
    DataDa(Tmsg(44), fnr, Tmsg(47), "r")
' Programmrahmen von GTK+tobac
    n = "C:\MicroSoft\Programme\kosten\Zeit\"
    FileDa(n, _OUT_.PNam, SufTobac) '             _tobac immer schreiben
    WITH _INI_
      IF .UiIn THEN FileDa(n, _OUT_.PNam, SufGui) '  _gui ggf. schreiben
      p = .Path + slash
      IF .Toba THEN rausblau(Tmsg(58)) : raus(p & NL)
      FileDa(p, _OUT_.PNam, SufBas) : showBas()
      IF .Make   THEN FileDa(p, NamMkf, "")
      IF .ReadMe THEN FileDa(p, NamRdm, SufRdm)
      IF .Geany  THEN FileDa(p, _OUT_.PNam, SufGea)
      IF .FbIde  THEN FileDa(p, _OUT_.PNam, SufIde)
      IF .FbEdit THEN FileDa(p, _OUT_.PNam, SufEdi)
      IF .Jelly  THEN FileDa(p, _OUT_.PNam, SufJel)
      IF .Win    THEN FileDa(p, _OUT_.PNam, SufWin)
    END WITH
    raus(Tmsg(13)+NL)
  ELSE ' to much elements / zu viele Elemente
    n = *IIF(a=-1, @Tmsg(48), @Tmsg(49))+" (>"+ STR(IIF(a=-1, AzCB, AzUN))
    rausrot(Tmsg(50) + n +")")
    _OUT_.PNam = ""
  END IF
END SUB

'*
'*  writes code for integration of Glade XML file
'*  Schreibt das Modul zur Integration der Glade XML-Datei
'***********************************************************************
SUB write_code_gui (BYVAL p AS STRING, BYVAL n AS STRING)
  DIM AS INTEGER FnBa = FREEFILE
  raus(Tmsg(32)) : rausblau(n)
  IF OPEN (p + n FOR OUTPUT AS #FnBa) THEN
    rausrot(Tmsg(33)+NL)
  ELSE
    fill_code_gui(FnBa)
    CLOSE #FnBa
    raus(Tmsg(34)+NL)
  END IF
END SUB

'*
'*  Checking input and generating program coding / declarations
'*  Eingaben pruefen und Programmcode bzw. Deklarationen erzeugen
'***********************************************************************
SUB generate_coding ()
  DIM AS STRING  n, p = _INI_.Path + slash
  checkPara()
  IF _INI_.Toba THEN p += OrdTobac : MKDIR(p) : p += slash
' clear the message field
  rausclr(Tmsg(51))
' Check if a glade file is loaded
  IF _OUT_.PNam = "" THEN rausrot(Tmsg(21)) : EXIT SUB
  rausblau(Tmsg(58)) : raus(p & NL)
' include files for callbacks
  FOR i AS INTEGER = 0 TO AzCB - 1
    n = MID(NaCB(i), 5) & SufBas
    IF NOT FILEEXISTS(p+n) THEN fill_code_callb(NaCB(i)) : write_code(p, n)
  NEXT i
' programmers include files
  n = _OUT_.PNam + SufTobac :       fill_code_tobac()        : write_code(p, n)
  WITH _INI_
    IF .UiIn THEN n = _OUT_.PNam + SufGui :                write_code_gui(p, n)
    n = _OUT_.PNam + SufBas : p = .Path + slash
    rausblau(Tmsg(58)) : raus(p & NL)
    IF NOT FILEEXISTS(p + n) THEN fill_code_bas()          : write_code(p, n)
    IF .Make THEN
      n = NamMkf
      IF NOT FILEEXISTS(p + n) THEN fill_code_make(_OUT_.PNam) : write_code(p, n)
    END IF
    IF .ReadMe THEN
      n = NamRdm & SufRdm
      IF NOT FILEEXISTS(p + n) THEN fill_code_ReadMe() : write_code(p, n)
    END IF
    IF .Geany THEN
      n = _OUT_.PNam + SufGea
      IF NOT FILEEXISTS(p + n) THEN fill_code_Geany(p) : write_code(p, n)
    END IF
    IF .FbIde THEN
      n = _OUT_.PNam + SufIde
      IF NOT FILEEXISTS(p + n) THEN fill_code_FbIde(_OUT_.PNam) : write_code(p, n)
    END IF
    IF .FbEdit THEN
      n = _OUT_.PNam + SufEdi
      IF NOT FILEEXISTS(p + n) THEN fill_code_FbEdit(_OUT_.PNam) : write_code(p, n)
    END IF
    IF .Jelly THEN
      n = _OUT_.PNam + SufJel
      IF NOT FILEEXISTS(p + n) THEN fill_code_Jelly(_OUT_.PNam) : write_code(p, n)
    END IF
    IF .Win THEN
      n = _OUT_.PNam + SufWin
      IF NOT FILEEXISTS(p + n) THEN fill_code_WinRc(_OUT_.PNam) : write_code(p, n)
    END IF
  END WITH : raus(Tmsg(13)+NL)
END SUB

'*
'* Parsing the command line / Auswertung der Kommandozeile
'***********************************************************************
SUB command_auswerten()
  DIM AS STRING t = PROG_NAME & "(" & PROG_VERS & ")"
' Calc len of filename / Laenge des Dateinamens ermitteln
  DIM AS INTEGER p = INSTR(LCASE(COMMAND), SufGla), Farb = COLOR
  IF p THEN p + = 3 ELSE p = INSTR(LCASE(COMMAND), SufBui)
  p = IIF(p, p + 3, 1)
' Set english when required / Auf Englisch schalten
  IF INSTR(p, COMMAND, "-v") THEN
    t += " compiled: " & __DATE__ & ", " & __TIME__ & " for "
    IF SLASH = "/" THEN t += "LINUX." ELSE t+= "win32."
    raus(t & NL) : COLOR LOWORD(Farb), HIWORD(Farb) : END 0
  END IF
  IF INSTR(p, COMMAND, "-len") THEN set_leng()
' Welcome / Willkommensmeldung
  rausclr(Tmsg(1))
  raus(Tmsg(2)) : rausblau(t) : raus(Tmsg(4))
' On Help / Wenn Hilfe gefordert
  IF INSTR(p, COMMAND, "-h") THEN
    FOR i AS INTEGER = 1 TO AZThelp - 1
      raus(Thelp(i))
    NEXT
    IF p > 1 THEN rausrot(Thelp(AZThelp))
    COLOR LOWORD(Farb), HIWORD(Farb) : END 0
  END IF
' set flag for including .UiIne file / Schalter fuer .UiIne inkludieren
  IF INSTR(p, COMMAND, "-i") THEN _INI_.UiIn = TRUE
' set flag for including .UiIne file / Schalter fuer .UiIne inkludieren
  IF INSTR(p, COMMAND, "-t") THEN _INI_.Toba = FALSE
' run, if filename set / automatischer Ablauf, wenn Dateiname angegeben
  IF p > 1 THEN
    read_UIfile(CURDIR & SLASH & LEFT(COMMAND, p - 1))
    raus(readSignals(MyDir & SIGDEF) & NL)
    IF LEN(_OUT_.PNam) THEN
      IF INSTR(p, COMMAND, "-N") THEN
' do nothing / nichts machen
      ELSE
        IF INSTR(p, COMMAND, "-n") THEN
          SELECT CASE Antwort(Tmsg(5), Tmsg(6), Tmsg(7), Tmsg(8))
            CASE 1 : raus(Tmsg(9)+NL) : generate_coding()
            CASE 2 : raus(Tmsg(10)+NL)
            CASE ELSE
              raus(Tmsg(11)+NL) : COLOR LOWORD(Farb), HIWORD(Farb) : END 0
          END SELECT
        ELSE
          generate_coding()
        END IF
      END IF
      IF INSTR(p, COMMAND, "-A") THEN
        rausclr(Tmsg(12)+NL) : callback_clear(3) : raus(Tmsg(13))
      END IF
      IF INSTR(p, COMMAND, "-a") THEN
        rausclr(Tmsg(12)+NL) : callback_clear(2) : raus(Tmsg(13))
      END IF
      COLOR LOWORD(Farb), HIWORD(Farb) : END 0
    ELSE
' load error / Lesefehler
      raus(Tmsg(14))
    END IF
  ELSE
    p = INSTR(COMMAND, "-")
    IF p > 1 THEN
' load error / Lesefehler
      rausrot(Tmsg(15) + LEFT(COMMAND, p - 1) & NL)
      raus(Tmsg(14))
    END IF
  END IF : COLOR LOWORD(Farb), HIWORD(Farb)
END SUB

'*
'* function after ending main loop
'* Funktion nach Beendigung der Hauptschleife
'***********************************************************************
FUNCTION GUI_exit CDECL(BYVAL ud AS gpointer) AS gboolean
  GUIgetPara()
  INIsavePara()
  RETURN FALSE
END FUNCTION

'*
'* setting text in entry field
'* schreibt text in Entry
'***********************************************************************
SUB entry_set_text(BYVAL w AS GObject PTR, BYVAL t AS STRING)
  IF LEN(t) THEN gtk_entry_set_text(GTK_ENTRY(w), t) : EXIT SUB
  gtk_entry_set_text(GTK_ENTRY(w), "")
END SUB

'*
'* Including icon into binary, returning GdkPixbuf PTR
'* liest Icon in das Kompilat, liefert PTR auf GdkPixbuf
'***********************************************************************
FUNCTION readIcon() AS GdkPixbuf PTR
  DIM icon AS UBYTE PTR
  DIM icon_len AS UINTEGER
#IF __FB_DEBUG__
  ASM jmp .LT_END_OF_FILE_ICON_DEBUG_JMP
#ELSE
  ASM .section .data
 #ENDIF
  ASM .LT_START_OF_FILE_ICON:
  ASM __icon__start = .
  ASM .incbin "GTK+tobac2.pixdata"
  ASM __icon__len = . - __icon__start
  ASM .LT_END_OF_FILE_ICON:
#IF __FB_DEBUG__
  ASM .LT_END_OF_FILE_ICON_DEBUG_JMP:
#ELSE
  ASM .section .text
  ASM .balign 16
#ENDIF
  ASM .LT_SKIP_FILE_ICON:
  ASM mov dword PTR [icon], offset .LT_START_OF_FILE_ICON
  ASM mov dword PTR [icon_len], offset __icon__len
  RETURN gdk_pixbuf_new_from_inline(icon_len, icon, 0, 0)
END FUNCTION

'*
'* Initializing the GUI
'* Initialisierung die Benutzeroberflaeche
'***********************************************************************
SUB GUI_init()
  WITH _INI_
    ' setting entrys / setzt Entry-Felder
    entry_set_text( EntName, .Auth)
    entry_set_text(EntEmail, .Mail)
    entry_set_text(  EntWeb, .Site)
    entry_set_text(  EntSyn, .Desc)
    entry_set_text(  EntVer, .Vers)
    gtk_toggle_button_set_active(GTK_TOGGLE_BUTTON(   CheOld), .Old)
    entry_set_text(EntTyNa, .TyNa)

    ' setting toggle buttons
    gtk_toggle_button_set_active(GTK_TOGGLE_BUTTON( CheGlaIn), .UiIn)
    gtk_toggle_button_set_active(GTK_TOGGLE_BUTTON( CheTobac), .Toba)
    gtk_toggle_button_set_active(GTK_TOGGLE_BUTTON(  CheMake), .Make)
    gtk_toggle_button_set_active(GTK_TOGGLE_BUTTON(CheReadMe), .ReadMe)
    gtk_toggle_button_set_active(GTK_TOGGLE_BUTTON( CheGeany), .Geany)
    gtk_toggle_button_set_active(GTK_TOGGLE_BUTTON( CheFbIde), .FbIde)
    gtk_toggle_button_set_active(GTK_TOGGLE_BUTTON(CheFbEdit), .FbEdit)
    gtk_toggle_button_set_active(GTK_TOGGLE_BUTTON( CheJelly), .Jelly)
    gtk_toggle_button_set_active(GTK_TOGGLE_BUTTON(   CheWin), .Win)
    gtk_toggle_button_set_active(GTK_TOGGLE_BUTTON(    CheRc), .Rc)
    IF .Win = 0 THEN gtk_widget_set_sensitive(GTK_WIDGET(CheRc), 0)

    ' setting window / setzt Fenstergroesse
    DIM AS INTEGER w, h
    SCREENINFO w, h '                             Validitaet pruefen
    .Brei = MIN(MAX(.Brei, 580), w)
    .Hoch = MIN(MAX(.Hoch, 480), h)
    gtk_window_resize(GTK_WINDOW(win_main), .Brei, .Hoch)
    gtk_window_set_icon(GTK_WINDOW(win_main), readIcon())
  END WITH

  ' setting mono font / setzt den Zeichensatz auf Mono
  DIM AS ANY PTR P = pango_font_description_from_string("mono 10")
  gtk_widget_modify_font(GTK_WIDGET(TeVMessage), P)
  pango_font_description_free (P)

  ' Referenziert den buffer und schaltet auf nicht editierbar
  buffer = gtk_text_view_get_buffer(GTK_TEXT_VIEW(TeVMessage))
  gtk_text_view_set_editable(GTK_TEXT_VIEW(TeVMessage), NULL)

  ' define some text sytles / einige Textstile definieren
  gtk_text_buffer_create_tag(buffer, "lmarg", "left_margin", 5, NULL)
  gtk_text_buffer_create_tag(buffer, "blue_fg", "foreground", "blue", NULL)
  gtk_text_buffer_create_tag(buffer, "red_fg", "foreground", "red", NULL)
  gtk_text_buffer_create_tag(buffer, "gray_bg", "background", "gray", NULL)
  gtk_text_buffer_create_tag(buffer, "italic", "style", PANGO_STYLE_ITALIC, NULL)
  gtk_text_buffer_create_tag(buffer, "bold", "weight", PANGO_WEIGHT_BOLD, NULL)

  ' Load License / Lizenzdateien laden
  LIZloadNames(MyDir & OrdData & SLASH)
  ' GUI language init / setzt Oberflaechensprache
  set_GUI_lang()

  ' setting function to be called at end / setzt exit-Funktion
  gtk_quit_add(0, @GUI_exit(), 0)
  raus(NL & readSignals(MyDir & SIGDEF))
END SUB
